/*
 * Created on 10 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.infovis.column;


/**
 * 
 * Aggregator of value
 * This aggregator add the two values.
 * 
 * 
 * @author raf
 *
 * 
 */
public class SumValueAggregator extends ValueAggregator {
	/**
	 * Default constructor
	 */
	public SumValueAggregator() {
		super();
		
	}
	/**
	 * 
	 * 
	 * @param value1 the first double value to combine
	 * @param value2 the second double value to combine
	 * @return the sum of <code>value1</code> and <code>value2</code>
	 * 
	 * 
	 * @see fr.inria.infovis.column.ValueAggregator#aggregate(double, double)
	 */
	public String aggregate(double value1, double value2) {
		double result = value1 + value2;
		StringBuffer buffer = new StringBuffer();
		buffer.append(result);
		return buffer.toString();
	}
	/**
	 * 
	 * @param value1 the first long value to combine
	 * @param value2 the second long value to combine
	 * @return the sum of <code>value1</code> and <code>value2</code>
	 * 
	 * 
	 * @see fr.inria.infovis.column.ValueAggregator#aggregate(long, long)
	 */
	public String aggregate(long value1, long value2) {
		long result = value1 + value2;
		StringBuffer buffer = new StringBuffer();
		buffer.append(result);
		return buffer.toString();
	}
	/**
	 * 
	 * 
	 * @param value1 the first String value to combine
	 * @param value2 the second String value to combine
	 * @return the concatenation of <code>value1</code> and <code>value2</code>
	 * 
	 * @see fr.inria.infovis.column.ValueAggregator#aggregate(java.lang.String, java.lang.String)
	 */
	public String aggregate(String value1, String value2) {
		if (value1== null) return value2;
		if (value2 == null) return value1;
		try {
			long v1=Long.parseLong(value1);
			long v2=Long.parseLong(value2);
			return aggregate(v1,v2);
		} catch (NumberFormatException longException) {
			try {
				double v1=Double.parseDouble(value1);
				double v2=Double.parseDouble(value2);
				return aggregate(v1,v2);
			} catch (NumberFormatException doubleException) {
				return value1+'+'+value2;
			}
		}
	}
}
