
package fr.inria.infovis.panel;

import infovis.Column;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;


/**
 * @author raf
 *
 * A replacement of the ColumnListCellRenderer of Infovis
 * 
 * 
 */
public class ColumnListCellRenderer extends DefaultListCellRenderer {
    /**
     * @see javax.swing.ListCellRenderer#getListCellRendererComponent(JList, Object, int, boolean, boolean)
     */
    public Component getListCellRendererComponent(JList list, Object value,
                                                  int index,
                                                  boolean isSelected,
                                                  boolean cellHasFocus) {
        Column col = (Column)value;
        String newValue;
        if (col == null) {
            newValue = "(None)";
        } else {
            String colName = col.getName();
                //col.isInternal() ? "["+col.getName().substring(1)+"]" : col.getName();
            String type = col.getValueClass().getName();
            int    offset = type.lastIndexOf('.');
            if (offset != -1) {
                type = type.substring(offset + 1);
            }
            newValue = colName + " (" + type + ")";
        }
        return super.getListCellRendererComponent(list, newValue, index,
                                                  isSelected, cellHasFocus);
    }
}
