package fr.inria.infovis.panel.visualization;

import infovis.column.ColumnFilter;
import infovis.tree.visualization.NodeLinkTreeVisualPanel;
import infovis.tree.visualization.NodeLinkTreeVisualization;
import infovis.tree.visualization.TreeStructrureFilter;

import javax.swing.JComponent;

/**
 * @author raf
 *
 * A replacement of the NodeLinkTreeControlPanel of Infovis
 * 
 * 
 */
public class NodeLinkTreeControlPanel extends TreeControlPanel {
    public NodeLinkTreeControlPanel(NodeLinkTreeVisualization visualization) {
        this(visualization, TreeStructrureFilter.sharedInstance());
    }

    public NodeLinkTreeVisualization getNodeLinkTreeVisualization() {
        return (NodeLinkTreeVisualization)getVisualization()
            .findVisualization(NodeLinkTreeVisualization.class);
    }
        
    NodeLinkTreeControlPanel(NodeLinkTreeVisualization visualization, ColumnFilter filter) {
        super(visualization, filter);
        DefaultLinkVisualPanel.addVisualPanelTab(this,
            getNodeLinkTreeVisualization().getLinkVisualization(), 
            filter);
    }
    
    protected JComponent createVisualPanel() {
        JComponent ret = new NodeLinkTreeVisualPanel(getVisualization(), getFilter());
        return ret;
    }
}
