
package fr.inria.infovis.panel.visualization;

import infovis.column.ColumnFilter;
import infovis.table.visualization.ScatterPlotVisualPanel;
import infovis.table.visualization.ScatterPlotVisualization;

import javax.swing.JComponent;

import fr.inria.infovis.panel.DefaultControlPanel;

/**
 * @author raf
 *
 * A replacement of the ScatterPlotControlPanel of Infovis
 * 
 * 
 */
public class ScatterPlotControlPanel extends DefaultControlPanel {

    /**
     * Constructor for ScatterPlotControlPanel.
     * @param visualization
     */
    public ScatterPlotControlPanel(ScatterPlotVisualization visualization) {
        super(visualization);
    }

    /**
     * Constructor for ScatterPlotControlPanel.
     * @param visualization
     * @param filter
     */
    public ScatterPlotControlPanel(
        ScatterPlotVisualization visualization, ColumnFilter filter) {
        super(visualization, filter);
    }

    /**
     * Returns the ScatterPlotVisualization.
     * 
     * @return the ScatterPlotVisualization.
     */
    public ScatterPlotVisualization getScatterPlot() {
        return (ScatterPlotVisualization)getVisualization().
            findVisualization(ScatterPlotVisualization.class);
    }

    /**
     * @see infovis.panel.ControlPanel#createStdVisualPane()
     */
    protected JComponent createVisualPanel() {
        return new ScatterPlotVisualPanel(getScatterPlot(), getFilter());
    }

}
