/*
 * Created on 6 mai 2004
 *
 */
package fr.inria.infovis.temporizer;

import infovis.Column;
import infovis.Table;


/**
 * 
 * Specific Temporizer dedicated to Infovis Table
 * 
 * @author raf
 *
 */
public class TableTemporizer extends AbstractTemporizer {
	
	/**
	 * 
	 * Constructs a new temporizer for a table with a specific delay
	 * 
	 * @param d The delay in milliseconds
	 * @param g the graph to be temporized
	 */
	public TableTemporizer(int d, Table t) {
		super(d, t);
	}
	/**
	 * 
	 * Constructs a new temporizer for a table
	 * 
	 * @param g graph to be "temporized"
	 */
	public TableTemporizer(Table t) {
		super(t);
	}

	
		
	
	
	/**
	 * 
	 * Disable notification on a table
	 * 
	 * @see fr.inria.infovis.temporizer.AbstractTemporizer#disableNotify()
	 */
	
	protected void disableNotify() {
		Column c;
		for(int i=0; i < table.getColumnCount(); i++) {
			c=table.getColumnAt(i);
			c.disableNotify();
		}
		
		
	}
	/**
	 * 
	 * Enable notification on a Table
	 * 
	 * @see fr.inria.infovis.temporizer.AbstractTemporizer#disableNotify()
	 */
	protected void enableNotify() {
		Column c;
		for(int i=0; i < table.getColumnCount(); i++) {
			c=table.getColumnAt(i);
			try {
				c.enableNotify();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		
	}
}
