/*
 * Created on 13 avr. 2004
 *
 */
package fr.inria.oadymppac.application;

/**
 * 
 * Declares static table of global properties of an application.
 * 
 * 
 * @author raf
 *
 */
public interface ApplicationProperties {
	/**
	 * <code>APPLICATION</code> a reference to the current application instance
	 */
	public final static String APPLICATION="APPLICATION";
	/**
	 * <code>ACCELERATED_FRAME_CLASS</code> indicate if the application uses accelerated frame
	 */
	public final static String ACCELERATED_FRAME_CLASS="ACCELERATED_FRAME_CLASS";
	/**
	 * <code>MAIN_FRAME</code> a reference to the main JFrame of the application
	 */
	public final static String MAIN_FRAME="MAIN_FRAME";
	/**
	 * <code>APPLICATION_FRAME_DECORATOR</code> a reference to the JFrame decorator 
	 * The main decorator will add the main menus.
	 */
	public final static String APPLICATION_FRAME_DECORATOR="APPLICATION_FRAME_DECORATOR";
	/**
	 * <code>VISUALIZATION_FRAME_DECORATOR</code> a reference to the visualization frame decorator
	 * The visualization decorator will add the visualization features.
	 */
	public final static String VISUALIZATION_FRAME_DECORATOR="VISUALIZATION_FRAME_DECORATOR";
	
	/**
	 * <code>PANEL_FACTORY</code> a reference to the panel Factory of the application
	 */
	public final static String PANEL_FACTORY="PANEL_FACTORY";
	
	/**
	 * <code>ACTION_FACTORY</code> a reference to the action factory of the application 
	 */
	public final static String ACTION_FACTORY="ACTION_FACTORY";
	/**
	 * <code>FILE_MANAGER</code> a reference to a file manager of the applicatio
	 */
	public final static String FILE_MANAGER="FILE_MANAGER";
	/**
	 * <code>LOGGER</code> a refernce to the logger of the applcation
	 */
	public final static String LOGGER="LOGGER";
	/**
	 * <code>CURRENT_DOCUMENT</code> a reference to the current document
	 */
	public final static String CURRENT_DOCUMENT="CURRENT_DOCUMENT";
	/**
	 * <code>CURRENT_VISUALIZATION</code> a refernce to the current visualization (selected)
	 */
	public final static String CURRENT_VISUALIZATION="CURRENT_VISUALIZATION";
	/**
	 * <code>XML_VALIDATION</code> the current stat of validation (a command line argument)
	 */
	public final static String XML_VALIDATION="XML_VALIDATION";
	/**
	 * <code>HTTP_PROXY</code> A refernce to the HTTP proxy server address
	 */
	public final static String HTTP_PROXY="HTTP_PROXY";
	/**
	 * <code>HTTP_PROXYPORT</code> a refernce to the HTTP proxy server port
	 */
	public final static String HTTP_PROXYPORT="HTTP_PROXYPORT";
}
