/*
 * Created on 13 avr. 2004
 *
 */
package fr.inria.oadymppac.demo;

import java.io.File;

import javax.swing.JOptionPane;

import fr.inria.oadymppac.application.ApplicationProperties;
import fr.inria.oadymppac.application.MainApplication;
import fr.inria.oadymppac.io.FileManager;
import fr.inria.oadymppac.panel.ApplicationPanelFactory;
import fr.inria.oadymppac.panel.JListDialog;
import fr.inria.oadymppac.solver.analyser.SolverAnalyser;
import fr.inria.oadymppac.utils.log.LogConfigurator;

/**
 * 
 * Basically, lauch the application 
 * 
 * 
 * @author raf
 *
 */
public class Demo {
	/**
	 * start the application
	 * Analyse the command line arguments
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		File file =null;
		boolean openFile=false;
		FileManager fileManager=null;
		LogConfigurator.configure();
		MainApplication application = new MainApplication();
		if (args != null && args.length > 0) {
			for(int i=0; i < args.length;i++) {
				if (args[i].equals("-agile") || args[i].equals("-opengl")) {
					application.setProperty(ApplicationProperties.ACCELERATED_FRAME_CLASS, "agile2d.AgileJFrame");
				} else if (args[i].startsWith("-file=")) {
					file = new File(args[i].substring(6));
				} else if (args[i].equals("-open")) {
					openFile = true;
				} else if (args[i].startsWith("-validation=")) {
					application.setProperty(ApplicationProperties.XML_VALIDATION, args[i].substring(12));
				
				}
			}
		}
		
		application.initApplication();
		MainApplication.getFrame().pack();
	MainApplication.getFrame().setVisible(true);
	if (openFile) {
		fileManager = (FileManager) application.getProperty(ApplicationProperties.FILE_MANAGER);
		file =  (fileManager == null ? null : fileManager.selectFile());
	}
	if (file != null && file.exists()) {
		ApplicationPanelFactory panelFactory = (ApplicationPanelFactory) application.getProperty(ApplicationProperties.PANEL_FACTORY);               	
		JListDialog.setContent(SolverAnalyser.LABELS);
		if (panelFactory.buildAnalysisSelector() == JOptionPane.OK_OPTION) {	
			if (fileManager == null) fileManager = (FileManager) application.getProperty(ApplicationProperties.FILE_MANAGER);
			try {
				fileManager.loadFile(file);
			} catch (Exception e) {
				e.printStackTrace();
				panelFactory.buildErrorPanel(e);
			}	
			
		}
		
	}
}
}
