/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.examples.parsing;

import fr.inria.oadymppac.parsing.event.EventListenerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.handlers.ProvideContentHandler;


/**
 * 
 * An example of a Provide Handler
 * Basically its only display the event when provide occurs
 * But it can also build a structure representing the provide information
 * 
 * @author raf
 *
 *
 */
public class SingleProvideEventListener extends EventListenerImpl implements ProvideEventListener {
	    /**
	     * <code>HEAD</code> Static constant to recogize a HEADER PROVIDE listener
	     */
	    public static final String HEAD="HEAD";
	    /**
	     * <code>TRACE</code> Static constant to recogize a DOCUMENT PROVIDE listener
	     */
	    public static final String TRACE="TRACE";
	    
		/**
		 * <code>orig</code> The origin of the provide (HEAD or TRACE)
		 */
		private String orig;

		/**
		 * 
		 * Daefault constructor.
		 * 
		 * Force the user to precise the origin of the provide.
		 * 
		 * @param orig
		 */
		public SingleProvideEventListener(String orig) {
			super();
			this.orig = orig;
		}	
		
        /**
         * Process the Provide event, only display it on standard output
         * 
         * @see fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEvent)
         */
        public void eventProcess(ProvideEvent ev) {
        	System.out.println("------------------- NEW PROVIDE DEFINITION("+orig+") !!! -------------------\n"+ ((ProvideContentHandler) ev.getSource()).getProvideInfo() );
        } 
		/**
		 * @return Returns the origin of the provide
		 */
		public String getOrig() {
			return orig;
		}
		/**
		 * @param orig The origin of the provide to set.
		 */
		public void setOrig(String orig) {
			this.orig = orig;
		}

    }

