/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A. Author : raf COSYTEC 4 rue
 * Jean Rostand 91893 Orsay Cedex, France Tel. +33 1 60 19 37 38 Fax. +33 1 60
 * 19 36 20
 * 
 * Purpose : COMPLETE HERE
 * 
 * Created on 17 mars 2004
 * 
 *  
 */
package fr.inria.oadymppac.examples.parsing;
import java.util.Iterator;
import java.util.Vector;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListenerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.ExplanationReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEventListener;
import fr.inria.oadymppac.parsing.info.AnnotationCommandInfo;
import fr.inria.oadymppac.parsing.info.AnnotationInfo;
import fr.inria.oadymppac.parsing.info.BasicInfo;
import fr.inria.oadymppac.parsing.info.CauseInfo;
import fr.inria.oadymppac.parsing.info.CauseListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider;
import fr.inria.oadymppac.parsing.info.ChoicePointInfo;
import fr.inria.oadymppac.parsing.info.ConstraintInfo;
import fr.inria.oadymppac.parsing.info.ConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ConstraintsInfo;
import fr.inria.oadymppac.parsing.info.DeltaInfo;
import fr.inria.oadymppac.parsing.info.DeltaListInfo;
import fr.inria.oadymppac.parsing.info.DeltaListProvider;
import fr.inria.oadymppac.parsing.info.DeltaProvider;
import fr.inria.oadymppac.parsing.info.ExplanationInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.NewStageInfo;
import fr.inria.oadymppac.parsing.info.StageCommentInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateMiscInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListProvider;
import fr.inria.oadymppac.parsing.info.UpdateProvider;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValueListProvider;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.parsing.info.VarDomainProvider;
import fr.inria.oadymppac.parsing.info.VariableInfo;
import fr.inria.oadymppac.parsing.info.VariableListInfo;
/**
 * 
 * A single Trace Analyser Basically display GENTRA4CP Event structures Store
 * some event in a buffer (for potential post analysis...)
 * 
 * Only top level (i.e. just below a gentra4cp, packet, or breakpoint tags are
 * processed here.
 * 
 * @author raf
 *  
 */
public class SingleSolverEventListener extends EventListenerImpl
		implements
			NewVariableEventListener,
			NewConstraintEventListener,
			PostEventListener,
			ChoicePointEventListener,
			SolutionEventListener,
			FailureEventListener,
			AnnotationEventListener,
			AwakeEventListener,
			BackToEventListener,
			ReduceEventListener,
			RejectEventListener,
			RemoveEventListener,
			RestoreEventListener,
			ScheduleEventListener,
			SuspendEventListener,
			SolvedEventListener,
			StateEventListener,
			NewStageEventListener,
			StartStageEventListener,
			EndStageEventListener,
			SuspendStageEventListener,
			ResumeStageEventListener {
	/**
	 * <code>buffer</code> A buffer to store some events
	 */
	Vector buffer = new Vector();
	/**
	 * 
	 * Storing events
	 * 
	 * @param o :
	 *            the vent to store
	 */
	protected void add(Object o) {
		buffer.add(o);
	}
	/**
	 * 
	 * Processing a new-variable
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent)
	 */
	public void eventProcess(NewVariableEvent ev) {
		System.out
				.println("------------------ NEW VARIABLE EVENT!!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NAME:" + ev.getName());
		System.out.println("INTERNAL:" + ev.getInternal());
		System.out.println("EXTERNAL:" + ev.getExternal());
		showValueList(ev);
		showVarDomain(ev);
		showState(ev);
	}
	/**
	 * 
	 * Processing a new-constraint
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent)
	 */
	public void eventProcess(NewConstraintEvent ev) {
		System.out
				.println("------------------ NEW CONSTRAINT EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NAME:" + ev.getName());
		System.out.println("INTERNAL:" + ev.getInternal());
		System.out.println("EXTERNAL:" + ev.getExternal());
		showUpdates(ev);
		showState(ev);
	}
	/**
	 * 
	 * Processing a Post event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.PostEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent)
	 */
	public void eventProcess(PostEvent ev) {
		System.out
				.println("------------------ POST EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showState(ev);
	}
	/**
	 * 
	 * Process a choice-point event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent)
	 */
	public void eventProcess(ChoicePointEvent ev) {
		System.out
				.println("------------------ CHOICE POINT EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NODE:" + ev.getNode());
		ChoiceConstraintListProvider choicConstraintList = (ChoiceConstraintListProvider) ev;
		ChoiceConstraintListInfo choicConstraints = choicConstraintList
				.getChoiceConstraintList();
		System.out.println("CHOICE-CONSTRAINT LIST:" + choicConstraints
				+ " iterator:" + choicConstraints.iterator());
		showChoiceConstraints(ev);
		showState(ev);
		try {
			//ChoicePointInfo info = (ChoicePointInfo) ev.getInfo();
			BasicInfo info = (BasicInfo) ev.getInfo();
			add(info.clone());
		} catch (CloneNotSupportedException excp) {
			// TODO Auto-generated catch block
			excp.printStackTrace();
		}
	}
	/**
	 * 
	 * Process a solution event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent)
	 */
	public void eventProcess(SolutionEvent ev) {
		System.out
				.println("------------------ SOLUTION EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NODE:" + ev.getNode());
		System.out.println("NODENAME:" + ev.getNodeName());
		System.out.println("SOLUTION VALUE:" + ev.getValue());
		showChoiceConstraints(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a failure event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.FailureEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent)
	 */
	public void eventProcess(FailureEvent ev) {
		System.out
				.println("------------------ FAILURE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NODE:" + ev.getNode());
		System.out.println("NODENAME:" + ev.getNodeName());
		showChoiceConstraints(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a back-to event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.BackToEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent)
	 */
	public void eventProcess(BackToEvent ev) {
		System.out
				.println("------------------ BACK TO EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NODE:" + ev.getNode());
		System.out.println("NODE BEFORE:" + ev.getNodeBefore());
		showDeltas(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a reduce Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent)
	 */
	public void eventProcess(ReduceEvent ev) {
		System.out
				.println("------------------ REDUCE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("VARIABLE:" + ev.getVariable());
		showVarDomain(ev);
		showDelta(ev);
		showUpdate(ev);
		if (ev instanceof ExplanationReduceEvent) {
			showExplanations((ExplanationReduceEvent) ev);
		}
	}
	/**
	 * 
	 * Process a awake Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent)
	 */
	public void eventProcess(AwakeEvent ev) {
		System.out
				.println("------------------ AWAKE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showUpdate(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a schedule Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent)
	 */
	public void eventProcess(ScheduleEvent ev) {
		System.out
				.println("------------------ SCHEDULE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showScheduleActions(ev.getActions());
		showUpdate(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a remove Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent)
	 */
	public void eventProcess(RemoveEvent ev) {
		System.out
				.println("------------------ REMOVE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showState(ev);
	}
	/**
	 * 
	 * Process a restore Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent)
	 */
	public void eventProcess(RestoreEvent ev) {
		System.out
				.println("------------------ RESTORE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("VARIABLE:" + ev.getVariable());
		showDeltas(ev);
		showState(ev);
	}
	/**
	 * 
	 * Process a suspend Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent)
	 */
	public void eventProcess(SuspendEvent ev) {
		System.out
				.println("------------------ SUSPEND EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showState(ev);
	}
	/**
	 * 
	 * Process a solved event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent)
	 */
	public void eventProcess(SolvedEvent ev) {
		System.out
				.println("------------------ SOLVED EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showState(ev);
	}
	/**
	 * 
	 * Process a reject Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.RejectEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent)
	 */
	public void eventProcess(RejectEvent ev) {
		System.out
				.println("------------------ REJECT EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("CONSTRAINT:" + ev.getConstraint());
		showState(ev);
	}
	/**
	 * 
	 * Process an annotation Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent)
	 */
	public void eventProcess(AnnotationEvent ev) {
		System.out
				.println("------------------ ANNOTATION EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("ANNOTATION:" + ev.getIdentifier());
		AnnotationInfo annotation;
		AnnotationCommandInfo annotationInfo;
		try {
			annotation = (AnnotationInfo) ev.getInfo();
			annotationInfo = (AnnotationCommandInfo) annotation.getCommand();
			if (annotationInfo != null)
				System.out.println("COMMAND:" + annotationInfo.getCommand());
			else
				System.out.println("NO COMMAND PROVIDED");
		} catch (CloneNotSupportedException excp) {
			excp.printStackTrace();
		}
	}
	/**
	 * 
	 * Process a new-stage Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent)
	 */
	public void eventProcess(NewStageEvent ev) {
		System.out
				.println("------------------ NEW STAGE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("NEW STAGE:" + ev.getIdentifier());
		System.out.println("DETAIL:" + ev.getDetail());
		showStageReferences(ev.getReferences());
		NewStageInfo newstage;
		StageCommentInfo stageCommentInfo;
		try {
			newstage = (NewStageInfo) ev.getInfo();
			stageCommentInfo = (StageCommentInfo) newstage.getComment();
			if (stageCommentInfo != null)
				System.out.println("COMMENT:" + stageCommentInfo.getComment());
			else
				System.out.println("NO COMMAND PROVIDED");
		} catch (CloneNotSupportedException excp) {
			excp.printStackTrace();
		}
	}
	/**
	 * 
	 * Process a start-stage Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent)
	 */
	public void eventProcess(StartStageEvent ev) {
		System.out
				.println("------------------ START STAGE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("STAGE:" + ev.getStage());
	}
	/**
	 * 
	 * Process a suspend-stage Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent)
	 */
	public void eventProcess(SuspendStageEvent ev) {
		System.out
				.println("------------------ SUSPEND STAGE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("STAGE:" + ev.getStage());
	}
	/**
	 * 
	 * Process a resume-stage Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent)
	 */
	public void eventProcess(ResumeStageEvent ev) {
		System.out
				.println("------------------ RESUME STAGE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("STAGE:" + ev.getStage());
	}
	/**
	 * 
	 * Process a end-stage Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent)
	 */
	public void eventProcess(EndStageEvent ev) {
		System.out
				.println("------------------ END STAGE EVENT !!! ------------------");
		System.out.println("CHRONO:" + ev.getChrono());
		System.out.println("DEPTH:" + ev.getDepth());
		System.out.println("STAGE:" + ev.getStage());
	}
	/**
	 * 
	 * Process a state Event
	 * 
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent)
	 */
	public void eventProcess(StateEvent ev) {
		System.out
				.println("------------------ COMPLEMENT STATE EVENT !!! ------------------");
		StateInfo info = null;
		try {
			info = (StateInfo) ev.getInfo();
		} catch (CloneNotSupportedException excp) {
			logger.error("State Doesnot containt info", excp);
		}
		if (info != null)
			showState(info);
	}
	/**
	 * 
	 * Display the content of a value list contained by an event
	 * 
	 * @param ev
	 *            The event containing the valueListInfo
	 */
	protected void showValueList(Event ev) {
		ValueListProvider valueList = (ValueListProvider) ev;
		showValueList(valueList.getValueList());
	}
	/**
	 * 
	 * Display the content of a value list contained in a valueListInfo
	 * 
	 * @param dom :
	 *            the values to display
	 */
	protected void showValueList(ValueListInfo dom) {
		Iterator it = (dom == null ? null : dom.iterator());
		System.out.print("VALUE LIST:< ");
		while (it != null && it.hasNext())
			System.out.print((it.next()).toString() + " ");
		System.out.println(" >");
	}
	/**
	 * 
	 * Display the content of a choice constraints contained in an event
	 * 
	 * @param ev
	 *            the event containing the ChoiceCOnstraintInfo
	 */
	protected void showChoiceConstraints(Event ev) {
		ChoiceConstraintListProvider choicConstraintList = (ChoiceConstraintListProvider) ev;
		ChoiceConstraintListInfo choicConstraints = choicConstraintList
				.getChoiceConstraintList();
		if (choicConstraints != null)
			showChoiceConstraints(choicConstraints);
	}
	/**
	 * 
	 * Display the content of the choice constraints contained by the
	 * ConstraintListInfo
	 * 
	 * @param choicConstraints
	 */
	protected void showChoiceConstraints(
			ChoiceConstraintListInfo choicConstraints) {
		ChoiceConstraintInfo info;
		Iterator it = (choicConstraints == null ? null : choicConstraints
				.iterator());
		System.out.println("CHOICE CONSTRAINTS:< ");
		while (it != null && it.hasNext()) {
			info = (ChoiceConstraintInfo) it.next();
			System.out.println("\tVARIABLE:" + info.getVariable());
			System.out.println("\tVALUE:" + info.getValue());
		}
		System.out.println(" >");
	}
	/**
	 * Display the content of a list of delta from an event
	 * 
	 * @param ev
	 *            The event containing the DeltaListInfo
	 */
	protected void showDeltas(Event ev) {
		DeltaListProvider deltaList = (DeltaListProvider) ev;
		DeltaListInfo deltas = deltaList.getDeltaList();
		DeltaInfo info;
		Iterator it = (deltas == null ? null : deltas.iterator());
		System.out.println("UPDATES:< ");
		while (it != null && it.hasNext()) {
			info = (DeltaInfo) it.next();
			showDelta(info);
		}
		System.out.println(" >");
	}
	/**
	 * 
	 * Display the content of a update list from an event
	 * 
	 * @param ev
	 */
	protected void showUpdates(Event ev) {
		UpdateListProvider updateList = (UpdateListProvider) ev;
		UpdateListInfo updates = updateList.getUpdateList();
		if (updates != null)
			showUpdates(updates);
	}
	/**
	 * 
	 * Display the content of a update list from an UpdateListInfo
	 * 
	 * @param updates
	 */
	protected void showUpdates(UpdateListInfo updates) {
		UpdateInfo info;
		Iterator it = (updates == null ? null : updates.iterator());
		System.out.println("UPDATES:< ");
		while (it != null && it.hasNext()) {
			info = (UpdateInfo) it.next();
			showUpdate(info);
		}
		System.out.println(" >");
	}
	/**
	 * 
	 * Display a unique update from an event
	 * 
	 * @param ev :
	 *            the event containing the updateInfo
	 */
	protected void showUpdate(Event ev) {
		UpdateProvider update = (UpdateProvider) ev;
		UpdateInfo info = update.getUpdate();
		if (info != null)
			showUpdate(info);
	}
	/**
	 * 
	 * Display a unique update from an updateInfo
	 * 
	 * @param info
	 */
	protected void showUpdate(UpdateInfo info) {
		System.out.println("UPDATE VARIABLE:" + info.getVariable());
		showUpdateTypes(info.getType());
		ValueListInfo valueList = info.getValueList();
		if (valueList != null)
			showValueList(valueList);
		else
			System.out.println("No values provided for update");
	}
	/**
	 * 
	 * Display the content of a var domain from an event
	 * 
	 * @param ev
	 *            the event containing the vardomain
	 */
	protected void showVarDomain(Event ev) {
		VarDomainProvider vardomain = (VarDomainProvider) ev;
		VarDomainInfo info = vardomain.getVarDomain();
		if (info != null)
			showVarDomain(info);
	}
	/**
	 * 
	 * Display the content of a var domain from an VarDomainInfo
	 * 
	 * @param info
	 *            the VardomainInfo to display
	 */
	protected void showVarDomain(VarDomainInfo info) {
		System.out.println("VARIABLE DOMAIN:");
		System.out.println("\tMIN:" + info.getMin());
		System.out.println("\tMAX:" + info.getMax());
		System.out.println("\tSIZE:" + info.getSize());
		ValueListInfo valueList = info.getValueList();
		if (valueList != null)
			showValueList(valueList);
		else
			System.out.println("No values provided for update");
	}
	/**
	 * 
	 * Display the content of a delta from an event
	 * 
	 * @param ev
	 *            the event containing the delta info
	 */
	protected void showDelta(Event ev) {
		DeltaProvider vardomain = (DeltaProvider) ev;
		DeltaInfo info = vardomain.getDelta();
		if (info != null)
			showDelta(info);
	}
	/**
	 * 
	 * Display the content of a delta from a DeltaInfo
	 * 
	 * @param info :
	 *            the info to be displayed
	 */
	protected void showDelta(DeltaInfo info) {
		System.out.println("DELTA DOMAIN:" + info.getVariable());
		ValueListInfo valueList = info.getValueList();
		if (valueList != null)
			showValueList(valueList);
		else
			System.out.println("No values provided for update");
	}
	/**
	 * 
	 * Display an update types attribute
	 * 
	 * @param types
	 *            the values contained by the type attributes
	 */
	protected void showUpdateTypes(short[] types) {
		System.out.print("\tTYPES: < ");
		if (types != null && types.length > 0) {
			for (int i = 0; i < types.length - 1; i++)
				System.out.print("" + types[i] + ",");
			System.out.println("" + types[types.length - 1] + " >");
		} else {
			System.out.println(" >");
		}
	}
	/**
	 * 
	 * Display the actions of a ScheduleEvent
	 * 
	 * @param actions :
	 *            actions given into the schedule event
	 */
	protected void showScheduleActions(String[] actions) {
		System.out.print("\tACTIONS: < ");
		if (actions != null && actions.length > 0) {
			for (int i = 0; i < actions.length - 1; i++)
				System.out.print(actions[i] + ",");
			System.out.println("" + actions[actions.length - 1] + " >");
		} else {
			System.out.println(" >");
		}
	}
	/**
	 * 
	 * Display the references to other stages
	 * 
	 * @param references
	 *            the stages referenced
	 *  
	 */
	protected void showStageReferences(String[] references) {
		System.out.print("\tREFERENCES: < ");
		if (references != null && references.length > 0) {
			for (int i = 0; i < references.length - 1; i++)
				System.out.print(references[i] + ",");
			System.out.println("" + references[references.length - 1] + " >");
		} else {
			System.out.println(" >");
		}
	}
	/**
	 * 
	 * Display the state containd by an event
	 * 
	 * @param ev
	 *            The event containing the state
	 *  
	 */
	protected void showState(Event ev) {
		StateProvider state = (StateProvider) ev;
		StateInfo info = state.getState();
		if (info != null)
			showState(info);
	}
	/**
	 * 
	 * Display the state from a StateInfo
	 * 
	 * @param info
	 */
	protected void showState(StateInfo info) {
		System.out.println("STATE:");
		System.out.println("\tCHRONO:" + info.getChrono());
		System.out.println("\tDEPTH:" + info.getDepth());
		System.out.println("\tCURRENT NODE:" + info.getCurrentNode());
		VariableListInfo variables = info.getVariableList();
		if (variables != null) {
			System.out.print("\t");
			showVariables(variables);
		}
		ConstraintListInfo constraints = info.getConstraintList();
		if (constraints != null) {
			System.out.print("\t");
			showContraintList(constraints);
		}
		UpdateListInfo updates = info.getUpdateList();
		if (updates != null) {
			System.out.print("\t");
			showUpdates(updates);
		}
		StateMiscInfo misc = info.getMisc();
		if (misc != null)
			System.out.println("\tMISC:" + misc.getMisc());
	}
	/**
	 * 
	 * Display a list of contents of VariableInfo
	 * 
	 * @param variables
	 */
	protected void showVariables(VariableListInfo variables) {
		VariableInfo info;
		Iterator it = (variables == null ? null : variables.iterator());
		System.out.println("STATE VARIABLES:< ");
		while (it != null && it.hasNext()) {
			info = (VariableInfo) it.next();
			System.out.print("\t");
			showVariable(info);
		}
		System.out.println(" >");
	}
	/**
	 * 
	 * Display a VaraibleInfo
	 * 
	 * @param info :
	 *            the variableInfo to display
	 */
	protected void showVariable(VariableInfo info) {
		System.out.println("\tSTATE VARIABLE:" + info.getIdentifier());
		System.out.println("\tNAME:" + info.getName());
		System.out.println("\tINTERNAL:" + info.getInternal());
		System.out.println("\tEXTERNAL:" + info.getExternal());
		ValueListInfo valueList = info.getValueList();
		if (valueList != null) {
			System.out.print("\t");
			showValueList(valueList);
		}
		VarDomainInfo varDomain = info.getVarDomain();
		if (varDomain != null) {
			System.out.print("\t");
			showVarDomain(varDomain);
		}
	}
	/**
	 * 
	 * Display a list of content of ConstraintInfo
	 * 
	 * @param constraints : list of ConstraintInfo
	 */
	protected void showContraintList(ConstraintListInfo constraints) {
		ConstraintInfo info;
		Iterator it = (constraints == null ? null : constraints.iterator());
		System.out.println("STATE CONSTRAINTS:< ");
		while (it != null && it.hasNext()) {
			info = (ConstraintInfo) it.next();
			System.out.print("\t");
			showConstraint(info);
		}
		System.out.println(" >");
	}
	/**
	 * 
	 * Display a ConstraintInfo
	 * 
	 * @param info : the ConstraintInfo to display
	 */
	protected void showConstraint(ConstraintInfo info) {
		System.out.println("\tSTATE CONSTRAINT:" + info.getIdentifier());
		System.out.println("\tNAME:" + info.getName());
		System.out.println("\tINTERNAL:" + info.getInternal());
		System.out.println("\tEXTERNAL:" + info.getExternal());
		UpdateListInfo updateList = info.getUpdateList();
		if (updateList != null) {
			System.out.print("\t");
			showUpdates(updateList);
		}
	}
	/**
	 * 
	 * Display explanations contained by a (reduce) event
	 * 
	 * @param ev : the event containing the expalantions
	 */
	protected void showExplanations(ExplanationReduceEvent ev) {
		System.out
				.println("---------- SHOWING EXPLANATIONS  ---------------------");
		ExplanationListInfo explanations = ev.getExplanationList();
		Iterator it = explanations.iterator();
		ExplanationInfo info;
		while (it != null && it.hasNext()) {
			info = (ExplanationInfo) it.next();
			System.out.println("EXPLANATION: " + info);
			System.out.print("\t");
			showValueList(info.getValueList());
			showConstraints(info.getConstraints());
			showCauseList(info.getCauseList());
		}
	}
	/**
	 * 
	 * Display the content of a ConstraintsInfo
	 * 
	 * @param info : the ConstraintsInfo to display
	 */
	protected void showConstraints(ConstraintsInfo info) {
		String[] references = (info == null ? null : info.getReferences());
		System.out.print("\tCONSTRAINTS REFERENCES: < ");
		if (references != null && references.length > 0) {
			for (int i = 0; i < references.length - 1; i++)
				System.out.print(references[i] + ",");
			System.out.println("" + references[references.length - 1] + " >");
		} else {
			System.out.println(" >");
		}
	}
	/**
	 * Display a list of content of CauseInfo
	 * 
	 * 
	 * @param causes : the list of CauseInfo to display
	 */
	protected void showCauseList(CauseListInfo causes) {
		CauseInfo info;
		Iterator it = (causes == null ? null : causes.iterator());
		System.out.println("\tCAUSES:< ");
		int i = 0;
		while (it != null && it.hasNext()) {
			info = (CauseInfo) it.next();
			System.out.println("\t\tCAUSE " + i++);
			System.out.println("\t\t\tVARIABLE:" + info.getVariable());
			System.out.println("\t\t\tTYPE:" + info.getType());
			System.out.print("\t\t\t");
			showValueList(info.getValueList());
		}
		System.out.println("\t >");
	}
	
	
	/**
	 * 
	 * Show the currently stored events
	 * 
	 */
	public void show() {
		System.out
				.println("---------- SHOWING STORED INFO  ---------------------");
		Iterator it = buffer.iterator();
		ChoicePointInfo info;
		while (it != null && it.hasNext()) {
			info = (ChoicePointInfo) it.next();
			System.out.println("STORED CHOICE-POINT: " + info);
			showChoiceConstraints(info.getChoiceConstraintList());
		}
	}
}