/*
 * Created on 5 avr. 2004
 *
 */
package fr.inria.oadymppac.io;

import java.io.File;

import javax.swing.filechooser.FileFilter;



/**
 * 
 * An implementation of a GENTRA4CP file filter to use inside
 * a file selector
 * 
 * @author raf
 *
 */
public class GenericTraceFileFilter extends FileFilter {
    /**
     *  <code>EXTENSION</code> Default extension for GENTRA4CP file
     */
    public static final String EXTENSION=".xml";
    /**
     * <code>COMPRESSED_EXT</code> Deffault extension for GENTRACP file when compressed
     */
    public static final String COMPRESSED_EXT=EXTENSION+".gz";

    /**
     * 
     * To be displayed in the selector, the file must be <ul>
     * <li> readable </li>
     * <li> or a directory </li>
     * <li> or a file with a name ending by EXTENSION </li>
     * <li> or a file with a name ending by COMPRESSED_EXT </li>
     * </ul>
     * 
     * 
     * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
     */
    public boolean accept(File f) {
        return  f.canRead() && 
        	    (f.isDirectory() || (
        	       f.getName().endsWith(EXTENSION) ||
                   f.getName().endsWith(COMPRESSED_EXT)));
    }
    /** 
     * 
     * A description to display in the JFileChooser
     * 
     * @see javax.swing.filechooser.FileFilter#getDescription()
     */
    public String getDescription() {
        return "GENTRA4CP files";
    }
}
