/*
 * Created on 25 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.panel;

import infovis.Table;
import infovis.Visualization;
import infovis.graph.visualization.GraphVisualization;
import infovis.graph.visualization.MatrixVisualization;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Rectangle;

import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JViewport;
import javax.swing.SwingConstants;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

import fr.inria.infovis.panel.AbstractControlPanel;
import fr.inria.infovis.panel.VisualizationPanel;
import fr.inria.infovis.table.LayeredTable;
import fr.inria.oadymppac.application.ApplicationProperties;
import fr.inria.oadymppac.utils.Properties;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class VisualizationInternalFrame extends JInternalFrame implements InternalFrameListener {
		public final static int DEFAULT_WIDTH = 500;
		public final static int DEFAULT_HEIGHT = 500;
	
		protected Properties properties;
	
		protected JSplitPane splitter;
		protected HistoryController historyController;
		protected AbstractControlPanel controlPanel;
		protected JScrollPane scrollPane;
		protected VisualizationPanel visualizationPanel;
		
		protected Table model ;
		
		public VisualizationInternalFrame(Properties props, Visualization visualization) {
			this.properties = props;
			setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
			setClosable(true);
			setResizable(true);
			setMaximizable(true);
			setIconifiable(true);
			if (visualization != null) {
				if (visualization instanceof GraphVisualization) {
					GraphVisualization gvis = (GraphVisualization) visualization;
					model = gvis.getGraph();
				} else {
					model= visualization.getTable();
				}
				
				if (model != null) {
					setTitle(model.getName());
				}					
				VisualizationInternalDecorator deco = new VisualizationInternalDecorator(visualization);
				visualizationPanel = new VisualizationInternalPanel(deco);
				visualizationPanel.setPreferredSize(new Dimension(1000,1000));				
				scrollPane = new JScrollPane(visualizationPanel);
				scrollPane.setWheelScrollingEnabled(true);
				String agile = (String) properties.getProperty(ApplicationProperties.ACCELERATED_FRAME_CLASS);
				if (agile != null && agile.equals("agile2d.AgileJFrame")) {
					scrollPane.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);					
				} else {
					scrollPane.getViewport().setScrollMode(JViewport.BLIT_SCROLL_MODE);
				}
				buildAdditionnalPanel(visualization,deco, agile );
				getContentPane().add(scrollPane);
				
			}
			this.addInternalFrameListener(this);
		}
		/**
		 * @return Returns the controlPanel.
		 */
		public synchronized AbstractControlPanel getControlPanel() {
			return controlPanel;
		}
		/**
		 * @param controlPanel The controlPanel to set.
		 */
		public synchronized void setControlPanel(
				AbstractControlPanel controlPanel) {
			this.controlPanel = controlPanel;
			
		}
		
		
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameActivated(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameActivated(InternalFrameEvent e) {
			if (this.controlPanel != null) {
		        int dl = splitter.getDividerLocation();   
		        splitter.remove(controlPanel);
		        splitter.add(this.controlPanel, JSplitPane.RIGHT);
		        splitter.setDividerLocation(dl);
			}
	        if (model != null && historyController != null && model instanceof LayeredTable) {
	        	LayeredTable layers = (LayeredTable) model;
	        	HistoryModel histoModel = historyController.getModel();
	        	histoModel.setColumns(layers.getLayeredColumns());
	        }

			properties.setProperty(ApplicationProperties.CURRENT_VISUALIZATION, this);
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameClosed(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameClosed(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameClosing(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameClosing(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameDeactivated(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameDeactivated(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameDeiconified(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameDeiconified(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameIconified(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameIconified(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
		/* (non-Javadoc)
		 * @see javax.swing.event.InternalFrameListener#internalFrameOpened(javax.swing.event.InternalFrameEvent)
		 */
		public void internalFrameOpened(InternalFrameEvent e) {
			// TODO Auto-generated method stub
		}
	
	
	class VisualizationInternalPanel extends VisualizationPanel /*implements Scrollable*/ {
		
		
			/**
		 * @param visualization
		 */
		public VisualizationInternalPanel(Visualization vis) {
			
			super(vis);
			
		}
		
//		
//		/* (non-Javadoc)
//		 * @see javax.swing.Scrollable#getPreferredScrollableViewportSize()
//		 */
//		public Dimension getPreferredScrollableViewportSize() {
//			return new Dimension(this.getWidth(),this.getHeight());
//		}
//		/* (non-Javadoc)
//		 * @see javax.swing.Scrollable#getScrollableBlockIncrement(java.awt.Rectangle, int, int)
//		 */
//		public int getScrollableBlockIncrement(Rectangle visibleRect,
//				int orientation, int direction) {
//			// TODO Auto-generated method stub
//			return 0;
//		}
//		/* (non-Javadoc)
//		 * @see javax.swing.Scrollable#getScrollableTracksViewportHeight()
//		 */
//		public boolean getScrollableTracksViewportHeight() {
//			// TODO Auto-generated method stub
//			return false;
//		}
//		/* (non-Javadoc)
//		 * @see javax.swing.Scrollable#getScrollableTracksViewportWidth()
//		 */
//		public boolean getScrollableTracksViewportWidth() {
//			// TODO Auto-generated method stub
//			return false;
//		}
//		/* (non-Javadoc)
//		 * @see javax.swing.Scrollable#getScrollableUnitIncrement(java.awt.Rectangle, int, int)
//		 */
//		public int getScrollableUnitIncrement(Rectangle visibleRect,
//				int orientation, int direction) {
//			// TODO Auto-generated method stub
//			return 0;
//		}
	}
		/**
		 * @return Returns the properties.
		 */
		public synchronized Properties getProperties() {
			return properties;
		}
		/**
		 * @param properties The properties to set.
		 */
		public synchronized void setProperties(Properties properties) {
			this.properties = properties;
		}
		/**
		 * @return Returns the scrollPane.
		 */
		public synchronized JScrollPane getScrollPane() {
			return scrollPane;
		}
		/**
		 * @param scrollPane The scrollPane to set.
		 */
		public synchronized void setScrollPane(JScrollPane scrollPane) {
			this.scrollPane = scrollPane;
		}
		/**
		 * @return Returns the splitter.
		 */
		public synchronized JSplitPane getSplitter() {
			return splitter;
		}
		/**
		 * @param splitter The splitter to set.
		 */
		public synchronized void setSplitter(JSplitPane splitter) {
			this.splitter = splitter;
		}
		/**
		 * @return Returns the visualizationPanel.
		 */
		public synchronized VisualizationPanel getVisualizationPanel() {
			return visualizationPanel;
		}
		/**
		 * @param visualizationPanel The visualizationPanel to set.
		 */
		public synchronized void setVisualizationPanel(
				VisualizationPanel visualizationPanel) {
			this.visualizationPanel = visualizationPanel;
		}
		
		public synchronized void forceRepaint() {
			Rectangle newBounds = new Rectangle();
			Rectangle oldBounds=bounds();
			newBounds.x = oldBounds.x;
			newBounds.y = oldBounds.y;
			newBounds.width = oldBounds.width;
			newBounds.height = oldBounds.height-1;               	
			setBounds(newBounds);
			setBounds(oldBounds);
			
		}
		
		protected void buildAdditionnalPanel(Visualization visualization, VisualizationInternalDecorator deco , String agile) {
			if (visualization instanceof  MatrixVisualization) {
				MatrixVisualization vis = (MatrixVisualization) visualization;
				vis.setLeftMargin(0);
				vis.setTopMargin(0);
				VisualizationHeaderDisplayer columnLabel = new VisualizationHeaderDisplayer(visualization);
				columnLabel.setName("Label");
				columnLabel.setDefaultLength(0); // No length limitation
				VisualizationHeaderDisplayer rowLabel = new VisualizationHeaderDisplayer(visualization, SwingConstants.VERTICAL);
				rowLabel.setName("Label");
				rowLabel.setDefaultSize(60);
				rowLabel.setDefaultLength(0); // No length limitation
				scrollPane.setColumnHeaderView(columnLabel);
				scrollPane.setRowHeaderView(rowLabel);
				if (agile != null && agile.equals("agile2d.AgileJFrame")) {
					scrollPane.getColumnHeader().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);
					scrollPane.getRowHeader().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);
				} else {
				scrollPane.getColumnHeader().setScrollMode(JViewport.BLIT_SCROLL_MODE);
				scrollPane.getRowHeader().setScrollMode(JViewport.BLIT_SCROLL_MODE);
				}
				Component[] components = new Component[2];
				components[0]=columnLabel;
				components[1]=rowLabel;
				deco.associated = components;
			}
		}
		
		
		
		/**
		 * @return Returns the historyController.
		 */
		public synchronized HistoryController getHistoryController() {
			return historyController;
		}
		/**
		 * @param historyController The historyController to set.
		 */
		public synchronized void setHistoryController(
				JComponent historyController) {
			this.historyController = (HistoryController) historyController;
			//this.historyController.setModel(table);
		}
}
