/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 9 mars 2004
 *
 * 
 */

package fr.inria.oadymppac.parsing;

import java.util.Collection;
import java.util.EmptyStackException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import fr.inria.oadymppac.parsing.event.ElementEventHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.parsing.event.EventListenerManager;

/**
 * @author raf
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public abstract class ContentHandlerImpl extends DefaultHandler implements
        ContentHandler, EventListenerManager, ElementHierarchyHandling {

	public static int fired=0;
	public static int initiated=0;
	public static int reset=0;
	
    protected ElementMap elementMap;

    protected HashMap delegateMap;

    protected EventListenerManager listenerManager;

    protected org.xml.sax.ContentHandler delegateHandler;

    protected String delegateElement;
    
    protected ElementHierarchyHandler hierarchy;

    private ElementEventHandler currentElementHandler;

    private Iterator currentIterator;

    private Event currentEvent;

    private String currentStack;
    /**
     *  
     */
    public ContentHandlerImpl() {
        this(null, null);

    }

    /**
     * @param nextHandler :
     *            next in the Chain of Responsibilty (DP)
     */
    public ContentHandlerImpl(String element, org.xml.sax.ContentHandler delegate) {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger
                        .info("Building new instance with nextHandler:"
                                + delegate);
        this.addDelegateHandler(element, delegate);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#getElementMap()
     */
    public Map getElementMap() {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("getting ElementMap:" + elementMap);
        return elementMap;
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#setElementMap(java.util.HashMap)
     */
    public void setElementMap(Map map) {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("setElementMap(" + map + ")");
        //elementMap = (HashMap) map;
        elementMap = (ElementMap) map;
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#into(java.lang.String)
     */
    public int into(String element) {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("calling into(" + element + ")");
        currentElementHandler = (ElementEventHandler) elementMap.get(element/*.intern()*/);
        if (currentElementHandler != null) {
            return currentElementHandler.depth();
        } else {
            return 0;
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.xml.sax.ContentHandler#characters(char[], int, int)
     */
    public void characters(char[] ch, int start, int length)
            throws SAXException {
        if (isDelegating()) {
    /*        if (ContentHandler.logger.isDebugEnabled())
                    ContentHandler.logger
                            .info("Keep on delegating characters '"
                                    + String.copyValueOf(ch, start, length)
                                    + "' to " + delegateHandler);
    */        delegateHandler.characters(ch, start, length);
        } else {
            if (currentElementHandler != null) {
      //          ContentHandler.logger.info("Current Element Handler ");
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
          //          if (ContentHandler.logger.isDebugEnabled())
          //                    ContentHandler.logger.info("Completing Event "
          //                          + currentEvent + " with characters "
          //                          + String.copyValueOf(ch, start, length));
                    currentEvent.init(this, ch, start, length);
                    
                }
          //      ContentHandler.logger.info("All events generated");
            }
        }
    }


    /*
     * (non-Javadoc)
     * 
     * @see org.xml.sax.ContentHandler#endElement(java.lang.String,
     *      java.lang.String, java.lang.String)
     */
    public void endElement(String namespaceURI, String localName, String qName)
            throws SAXException {
    //    if (ContentHandler.logger.isDebugEnabled())
    //            ContentHandler.logger.info("<<<<<<<<<<<<<<<<<<<<<<<  END_ELEMENT(" + qName + ") >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
        if (isDelegating()) {
            delegateHandler.endElement(namespaceURI, localName, qName);
            if (qName.equals(delegateElement)) {
      /*          if (ContentHandler.logger.isDebugEnabled())
                        ContentHandler.logger.info("Stop delegation of"
                                + delegateElement);
      */          delegateElement = null;
                delegateHandler = null;
            }
        } else {
        	if (!hierarchy.isEmpty()) {
        		currentStack=hierarchy.peek();
         		currentElementHandler = ((elementMap == null || !currentStack.endsWith(qName/*.intern()*/)) ? null
                        : (ElementEventHandler) elementMap.get(hierarchy.peek()));
        	}
        	if (currentElementHandler == null) currentElementHandler = (elementMap == null ? null
                    : (ElementEventHandler) elementMap.get(qName/*.intern()*/));
            if (currentElementHandler != null) {
      //          EventListenerManager.logger
      //                  .info("End Element FIRING event for " + qName/*.intern()*/
       //                         + "(" + currentElementHandler + ")");
       //        currentElementHandler.updateDepth(-1);
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
                    if (EventListenerManager.logger.isDebugEnabled())
       //                     EventListenerManager.logger.info("Terminating and Firing Event "
       //                             + currentEvent);
                    currentEvent.terminate();
                    fireEvent(currentEvent);
                    fired++;
                }
       //         EventListenerManager.logger.info("All events fired");
                 if(hierarchy != null ) 
                	try {
                		currentStack=hierarchy.pop();
                	} catch (EmptyStackException e) {
                		Event.logger.error("Popping an empty stack after end",e);
                	}
                currentElementHandler = null;
            }
        }
    //    if (ContentHandler.logger.isDebugEnabled())
    //        ContentHandler.logger.info("<<<<<<<<<<<<<<<<<<<<<<<  END_ELEMENT ("  + qName + ") TERMINATED >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.xml.sax.ContentHandler#startElement(java.lang.String,
     *      java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
    public void startElement(String namespaceURI, String localName,
            String qName, Attributes atts) throws SAXException {
 /*       if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("<<<<<<<<<<<<<<<<<<<<<<<  START_ELEMENT ("  + qName + ", " + atts + ") >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
   */     if (isDelegating()) {
     //       ContentHandler.logger.info("Keep on delegating");
            delegateHandler.startElement(namespaceURI, localName, qName, atts);
        } else {
        	if (hierarchy==null) hierarchy= this.buildHierarchyHandler();
        	if (!hierarchy.isEmpty()) {
        //		ContentHandler.logger.warn("Element in stack "+hierarchy.peek());
        		currentElementHandler = (elementMap == null ? null
                        : (ElementEventHandler) elementMap.get(Context.compose(hierarchy.peek(),qName/*.intern()*/)));
  //      		currentElementHandler = (elementMap == null ? null
  //                      : (ElementEventHandler) elementMap.get(compose(currentStack,qName/*.intern()*/)));
            	}
        	if (currentElementHandler == null) currentElementHandler = (elementMap == null ? null
                    : (ElementEventHandler) elementMap.get(qName/*.intern()*/));
            if (currentElementHandler != null) {
          //      ContentHandler.logger.info("Start Element Handler found");
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
            //        if (ContentHandler.logger.isDebugEnabled())
            //                ContentHandler.logger.info("Resetting Event "
            //                        + currentEvent);
                    currentEvent.reset();
                  
                }
            //   EventListenerManager.logger.info("All events reset"); 
            //    currentElementHandler.updateCount();
            //    currentElementHandler.updateDepth(+1);
                
            	currentStack=hierarchy.push(qName/*.intern()*/);
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
           //         if (ContentHandler.logger.isDebugEnabled())
           //                 ContentHandler.logger.info("Building Event "
           //                         + currentEvent);
                    
                    currentEvent.init(this, atts);
                   
                    
                    
                }
           //     ContentHandler.logger.info("All events generated");
            } else {
                delegateHandler = (delegateMap == null ? null
                        : (org.xml.sax.ContentHandler) delegateMap.get(qName/*.intern()*/));
                if (delegateHandler != null) {
             //       ContentHandler.logger.info("Element delegation found");
                    delegateElement = qName/*.intern()*/;
             //       ContentHandler.logger.info("Start delegating");
                    delegateHandler.startElement(namespaceURI, localName,
                            qName, atts);
                } else {
             //       ContentHandler.logger.warn("Element must be ignored ");
  //                  if (elementMap != null && ContentHandler.logger.isDebugEnabled())
  //                      ContentHandler.logger.warn(elementMap.toString());
                }
            }
        }
        //if (ContentHandler.logger.isDebugEnabled())
        //    ContentHandler.logger.info("<<<<<<<<<<<<<<<<<<<<<<<  START_ELEMENT ("  +qName + ") TERMINATED>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public Event addElement(String element, String ev)
            throws ClassNotFoundException, InstantiationException,
            IllegalAccessException {
        Class evClass = Class.forName(ev);
        return addElement(element/*.intern()*/, evClass);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public Event addElement(String element, Class ev)
            throws ClassNotFoundException, InstantiationException,
            IllegalAccessException {
        Event e = (Event) ev.newInstance();
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("New event created from class:" + e);
        return addElement(element/*.intern()*/, e);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public Event addElement(String element, Event ev) {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("addElement(" + element + ", " + ev
                        + ")");
       // if (elementMap == null) elementMap = new HashMap();
        if (elementMap == null) elementMap = new ElementMap();
        ElementEventHandler handler = (ElementEventHandler) elementMap.get(element/*.intern()*/);
        if (handler == null) {
            handler = buildElementHandler();
            elementMap.put(element/*.intern()*/, handler);
        }
        handler.addEvent(ev);
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("" + elementMap);
        return ev;
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ElementDelegationHandler#addDelegateHandler(java.lang.String,
     *      java.lang.Class)
     */
    public void addDelegateHandler(String element, Class handler)
            throws ClassNotFoundException, InstantiationException,
            IllegalAccessException {
        ContentHandler h = (ContentHandler) handler.newInstance();
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("New Handler created from class:"
                        + h);
        addDelegateHandler(element/*.intern()*/, h);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ElementDelegationHandler#addDelegateHandler(java.lang.String,
     *      java.lang.String)
     */
    public void addDelegateHandler(String element, String handler)
            throws ClassNotFoundException, InstantiationException,
            IllegalAccessException {
        Class handlerClass = Class.forName(handler);
        addDelegateHandler(element/*.intern()*/, handlerClass);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public void addDelegateHandler(String element, org.xml.sax.ContentHandler delegate) {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("addDelegate(" + element + ", "
                        + delegate + ")");
        if (element != null ) {
        	if (delegateMap == null) delegateMap = new HashMap();
        	org.xml.sax.ContentHandler handler = (org.xml.sax.ContentHandler) delegateMap.get(element/*.intern()*/);
        	if (handler == null) {
        		delegateMap.put(element/*.intern()*/, delegate);
        	} else {
        		if (ContentHandler.logger.isDebugEnabled())
        			ContentHandler.logger.error("Element " + element
                            + "is already delegated !");
        	}
        }else {
        	ContentHandler.logger.warn("Trying to add a null elment");
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public boolean isDelegating() {
        return delegateHandler != null;
    }

    

    public abstract EventListenerManager buildListenerManager();

    /**
     * @param e
     * @param l
     */
    public void addListener(Event e, EventListener l) {
        if (listenerManager == null) listenerManager = buildListenerManager();
        listenerManager.addListener(e, l);
    }

    /**
     * @param e
     * @param l
     */
    public void addListener(Class e, EventListener l) {
        if (listenerManager == null) listenerManager = buildListenerManager();
        listenerManager.addListener(e, l);
    }

    /**
     * @param e
     * @param l
     */
    public void addListener(String e, EventListener l) {
        if (listenerManager == null) listenerManager = buildListenerManager();
        listenerManager.addListener(e/*.intern()*/, l);
    }

    /**
     * @param e
     */
    public void fireEvent(Event e) {
        if (listenerManager != null) listenerManager.fireEvent(e);
    }

    /**
     * @param e
     * @return
     */
    public int getListenerCount(Event e) {
        return (listenerManager == null ? 0 : listenerManager
                .getListenerCount(e));
    }

    /**
     * @param e
     * @return
     */
    public int getListenerCount(Class e) {
        return (listenerManager == null ? 0 : listenerManager
                .getListenerCount(e));
    }

    /**
     * @param e
     * @return
     */
    public int getListenerCount(String e) {
        return (listenerManager == null ? 0 : listenerManager
                .getListenerCount(e/*.intern()*/));
    }

    /**
     * @param e
     * @return
     */
    public EventListener[] getListeners(Event e) {
        return (listenerManager == null ? null : listenerManager
                .getListeners(e));
    }

    /**
     * @param e
     * @return
     */
    public EventListener[] getListeners(Class e) {
        return (listenerManager == null ? null : listenerManager
                .getListeners(e));
    }

    /**
     * @param e
     * @return
     */
    public EventListener[] getListeners(String e) {
        return (listenerManager == null ? null : listenerManager
                .getListeners(e/*.intern()*/));
    }

    /**
     * @param e
     * @param l
     */
    public void removeListener(Event e, EventListener l) {
        if (listenerManager != null) listenerManager.removeListener(e, l);
    }

    /**
     * @param e
     * @param l
     */
    public void removeListener(Class e, EventListener l) {
        if (listenerManager != null) listenerManager.removeListener(e, l);
    }

    /**
     * @param e
     * @param l
     */
    public void removeListener(String e, EventListener l) {
        if (listenerManager != null) listenerManager.removeListener(e/*.intern()*/, l);
    }
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.ElementHierarchyHandling#buildHierarchyHandler()
	 */
	public ElementHierarchyHandler buildHierarchyHandler() {
		return new DefaultElementHierarchyHandler();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.ElementHierarchyHandling#getHierarchyHandler()
	 */
	public ElementHierarchyHandler getHierarchyHandler() {
		return hierarchy;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.ElementHierarchyHandling#inside(java.lang.String)
	 */
	public boolean inside(String element) {
		return hierarchy.contains(element/*.intern()*/);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.ElementHierarchyHandling#setHierarchyHandler(fr.inria.oadymppac.parsing.ElementHierarchyHandler)
	 */
	public void setHierarchyHandler(ElementHierarchyHandler handler) {
		this.hierarchy = handler;
	}
	
	
	class ElementMap extends TreeMap {
	    public String toString() {
	    	StringBuffer buf = new StringBuffer();
	    	buf.append("ELEMENT MAP: This :{");
	    	Iterator i = entrySet().iterator();
	            boolean hasNext = i.hasNext();
	            while (hasNext) {
	    	    Map.Entry e = (Map.Entry) (i.next());
	                Object key = e.getKey();
	                Object value = e.getValue();
	                buf.append("\t");
	                buf.append((key == this ?  "(this Map)" : key));
	                buf.append("=");
	                buf.append((value == this ? "(this Map)": value));
	                hasNext = i.hasNext();
	                if (hasNext)
	                    buf.append("\n");
	            }

	    	buf.append("}");
	    	return buf.toString();
	        }
	}
	
	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#endDocument()
	 */
	public void endDocument() throws SAXException {
		super.endDocument();
		
		Collection delegated = (delegateMap == null ? null : delegateMap.values());
		Iterator it=(delegated == null ? null : delegated.iterator());
		while(it != null && it.hasNext()) {
			org.xml.sax.ContentHandler handler = (org.xml.sax.ContentHandler) it.next();
			handler.endDocument();
		}
		EventListener[] listeners = (listenerManager == null ? null : listenerManager.getListenerList());
		for (int i=0; listeners != null && i < listeners.length; i++) {	
			listeners[i].processEnd();
		}
		
	}
	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#processingInstruction(java.lang.String, java.lang.String)
	 */
	public void processingInstruction(String target, String data)
			throws SAXException {
		super.processingInstruction(target, data);
		Collection delegated = (delegateMap == null ? null : delegateMap.values());
		Iterator it=(delegated == null ? null : delegated.iterator());
		while(it != null && it.hasNext()) {
			ContentHandler handler = (ContentHandler) it.next();
			handler.processingInstruction(target, data);
		}
		EventListener[] listeners = (listenerManager == null ? null : listenerManager.getListenerList());
		for (int i=0; listeners != null && i < listeners.length; i++) {
			listeners[i].processInstruction(target,data);
		}
	}
	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#startDocument()
	 */
	public void startDocument() throws SAXException {
		super.startDocument();
		
		Collection delegated = (delegateMap == null ? null : delegateMap.values());
		Iterator it=(delegated == null ? null : delegated.iterator());
		while(it != null && it.hasNext()) {
			org.xml.sax.ContentHandler handler = (org.xml.sax.ContentHandler) it.next();
			if (handler != null) handler.startDocument();
		}
		
		EventListener[] listeners = (listenerManager == null ? null : listenerManager.getListenerList());
		for (int i=0; listeners != null && i < listeners.length; i++) {
			listeners[i].processStart();
		}
		
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListenerManager#getListenerList()
	 */
	public EventListener[] getListenerList() {
		return (listenerManager == null ? null : listenerManager.getListenerList());
	}
}
