/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintEvent;
import fr.inria.oadymppac.parsing.info.ConstraintInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicConstraintEvent extends EventImpl implements ConstraintEvent {

    protected ConstraintInfo info;
    


 
    /**
     * 
     */
    public BasicConstraintEvent() {
        super();
        buildInfo();
    }

    protected void buildInfo() {
		if (info==null) info = new ConstraintInfo();
	}
    
    /**
     * @return
     */
    public String getExternal() {
        return info.getExternal();
    }
    /**
     * @return
     */
    public String getIdentifier() {
        return info.getIdentifier();
    }
    /**
     * @return Returns the info.
     */
    public Info getInfo() {
        return (Info)info;
    }
    /**
     * @return
     */
    public String getInternal() {
        return info.getInternal();
    }
    /**
     * @return
     */
    public String getName() {
        return info.getName();
    }
    /**
     * @return
     */
    public String getOrigin() {
        return info.getOrigin();
    }
    /**
     * @return
     */
    public String getStatus() {
        return info.getStatus();
    }
    
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setIdentifier(extractString(IDENTIFIER,atts, IDENTIFIER_NONE));
        setName(extractString(NAME,atts, NAME_NONE));
        setInternal(extractString(INTERNAL,atts, INTERNAL_NONE));
        setExternal(extractString(EXTERNAL,atts, EXTERNAL_NONE));
        setOrigin(extractString(ORIGIN,atts, ORIGIN_NONE));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset();
    	if (info != null) {
        setIdentifier(IDENTIFIER_NONE);
        setName(NAME_NONE);
        setInternal(INTERNAL_NONE);
        setExternal(EXTERNAL_NONE);
        setOrigin(ORIGIN_NONE);
        info=null;
    	}
    }
    /**
     * @param external
     */
    public void setExternal(String external) {
        info.setExternal(external);
    }
    /**
     * @param ident
     */
    public void setIdentifier(String ident) {
        info.setIdentifier(ident);
    }
    /**
     * @param internal
     */
    public void setInternal(String internal) {
        info.setInternal(internal);
    }
    /**
     * @param name
     */
    public void setName(String name) {
        info.setName(name);
    }
    /**
     * @param origin
     */
    public void setOrigin(String origin) {
        info.setOrigin(origin);
    }
    /**
     * @param status
     */
    public void setStatus(String status) {
        info.setStatus(status);
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}