/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import java.util.StringTokenizer;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsEvent;
import fr.inria.oadymppac.parsing.info.ConstraintsInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicConstraintsEvent extends EventImpl implements ConstraintsEvent,  Event
			 {
    
    private String buffer;
 
    protected ConstraintsInfo info;
    private StringTokenizer tokenizer;
 
  
    /**
     * 
     */
    public BasicConstraintsEvent() {
        super();
        buildInfo();
    }
    
    protected void buildInfo() {
		if (info==null) info = new ConstraintsInfo();
	}

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */    
    protected String[] extractIdentifiers(Attributes atts) {
        Event.logger.info("Extracting identifiers");
        buffer = atts.getValue(REFERENCES);
        int i;
        String[] result;
        if (buffer != null) {
            tokenizer=new StringTokenizer(buffer,REFERENCES_SEPARATOR);
            i=tokenizer.countTokens();
            if (i >0 ) {
                result= new String[i];
                i=0;
            } else {
                return REFERENCES_NONE;
            }
            while(tokenizer.hasMoreTokens()) {
                result[i++]=tokenizer.nextToken();
             }
            return result;
        } else {
            return REFERENCES_NONE;
        }
    }
    
    
    

    /**
     * @return
     */
    public String[] getReferences() {
        return info.getReferences();
    }
     
  
 
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
         setReferences(extractIdentifiers(atts));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset(); 
    	if (info != null) {
        
        setReferences(REFERENCES_NONE);
        info=null;
    	}
    }
 
    /**
     * @param identifiers
     */
    public void setReferences(String[] identifiers) {
        info.setReferences(identifiers);
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}