/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEvent;
import fr.inria.oadymppac.parsing.info.DeltaInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicDeltaEvent extends EventImpl implements DeltaEvent {
    
    protected DeltaInfo info;

    /**
     * 
     */
    public BasicDeltaEvent() {
        super();
        //buildInfo();
    }

 
    protected void buildInfo() {
		if (info==null) info = new DeltaInfo();
	}

   
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setVariable(extractString(VARIABLE,atts, VARIABLE_NONE));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
        super.reset();
        if (info != null) {
        setVariable(VARIABLE_NONE);
        info=null;
        }
    }



    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    /**
     * @return
     */
    public String getVariable() {
        return info.getVariable();
    }
    /**
     * @param variable
     */
    public void setVariable(String variable) {
        info.setVariable(variable);
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}