/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 10 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.EventAttributes;
import fr.inria.oadymppac.parsing.info.EventInfo;


/**
 * @author raf
 *
 * @
 */
public abstract class BasicEvent extends EventImpl implements EventAttributes {
    
    
    protected EventInfo info;
 
    
 
   
    /**
     * @return
     */
    public int getChrono() {
        logger.info("Resetting chrono");
        return info.getChrono();
    }
    /**
     * @return
     */
    public String getContext() {
        return info.getContext();
    }
    /**
     * @return
     */
    public int getDepth() {
        return info.getDepth();
    }
    /**
     * @return
     */
    public String getFile() {
        return info.getFile();
    }
    /**
     * @return
     */
    public int getLine() {
        return info.getLine();
    }
    /**
     * @return
     */
    public long getTime() {
        return info.getTime();
    }
    
    
 

    public void init(ContentHandler handler, Attributes atts) {
        if(logger.isDebugEnabled()) logger.info(this+".init("+handler+", "+atts+")");
        setChrono(extractInt(CHRONO,atts,CHRONO_NONE));
        setDepth(extractInt(DEPTH,atts,DEPTH_NONE));
        setTime(extractLong(TIME,atts,TIME_NONE));       
        setContext(extractString(CONTEXT,atts,CONTEXT_NONE)); 
        setLine(extractInt(LINE,atts,LINE_NONE));
        setFile(extractString(FILE,atts,FILE_NONE)); 
        allAttributes = atts;
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.AbstractEvent#reset()
     */
    public void reset() {
    	super.reset();
    	if (info != null) {
        setChrono(CHRONO_NONE);
        setDepth(DEPTH_NONE);
        setTime(TIME_NONE);
        setContext(CONTEXT_NONE);
        setLine(LINE_NONE);
        setFile(FILE_NONE); 
    	}
    }
    /**
     * @param chrono
     */
    public void setChrono(int chrono) {
        info.setChrono(chrono);
    }
    /**
     * @param context
     */
    public void setContext(String context) {
        info.setContext(context);
    }
    /**
     * @param depth
     */
    public void setDepth(int depth) {
        info.setDepth(depth);
    }
    /**
     * @param file
     */
    public void setFile(String file) {
        info.setFile(file);
    }
    /**
     * @param line
     */
    public void setLine(int line) {
        info.setLine(line);
    }
    /**
     * @param time
     */
    public void setTime(long time) {
        info.setTime(time);
    }
    
}
