/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import java.util.StringTokenizer;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.info.ConstraintListInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateMiscInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.VariableListInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicStateEvent extends BasicEvent implements StateEvent, Event
			 {
    
    private String buffer;
 
    protected StateInfo info;
    private StringTokenizer tokenizer;
    
    public BasicStateEvent() {
        super();
        buildInfo();
    }
    
    protected void buildInfo() {
		if (info==null) info = new StateInfo();
	}

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getChrono()
     */
    public int getChrono() {
        return info.getChrono();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getContext()
     */
    public String getContext() {
        return info.getContext();
    }
    /**
     * @return
     */
    public String getCurrentNode() {
        return info.getCurrentNode();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getDepth()
     */
    public int getDepth() {
        return info.getDepth();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getFile()
     */
    public String getFile() {
        return info.getFile();
    }
    /**
     * @return Returns the info.
     */
    public Info getInfo() {
        return (Info)info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getLine()
     */
    public int getLine() {
        return info.getLine();
    }
    /**
     * @return
     */
    public String getNextNode() {
        return info.getNextNode();
    }
    /**
     * @return
     */
    public String getNodeName() {
        return info.getNodeName();
    }
    /**
     * @return
     */
    public String getStatus() {
        return info.getStatus();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getTime()
     */
    public long getTime() {
        return info.getTime();
    }
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setCurrentNode(extractString(CURRENTNODE,atts, CURRENT_NODE_NONE));
        setNextNode(extractString(NEXTNODE,atts, NEXT_NODE_NONE));
        setNodeName(extractString(NODENAME,atts, NODENAME_NONE));
        setStatus(extractString(STATUS,atts, STATUS_NONE));
        setChoiceConstraints(extractString(CHOICECONSTRAINT,atts,CHOICECONSTRAINT_NONE));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
        logger.info("Resetting..."+info);
        super.reset();
        logger.info("Super reset");
        setCurrentNode(CURRENT_NODE_NONE);
        setNextNode(NEXT_NODE_NONE);
        setNodeName(NODENAME_NONE);
        setStatus(STATUS_NONE);
        setChoiceConstraints(CHOICECONSTRAINT_NONE);
        info=null;
        logger.info("Reset!");
    	}
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setChrono(int)
     */
    public void setChrono(int chrono) {
        info.setChrono(chrono);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setContext(java.lang.String)
     */
    public void setContext(String context) {
        info.setContext(context);
    }
    /**
     * @param node
     */
    public void setCurrentNode(String node) {
        info.setCurrentNode(node);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setDepth(int)
     */
    public void setDepth(int depth) {
        info.setDepth(depth);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setFile(java.lang.String)
     */
    public void setFile(String file) {
        info.setFile(file);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setLine(int)
     */
    public void setLine(int line) {
        info.setLine(line);
    }
    /**
     * @param node
     */
    public void setNextNode(String node) {
        info.setNextNode(node);
    }
    /**
     * @param node
     */
    public void setNodeName(String node) {
        info.setNodeName(node);
    }
    /**
     * @param node
     */
    public void setStatus(String node) {
        info.setStatus(node);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setTime(long)
     */
    public void setTime(long time) {
        info.setTime(time);
    }
    /**
     * @return
     */
    public String getChoiceConstraints() {
        return info.getChoiceConstraints();
    }
    /**
     * @return
     */
    public ConstraintListInfo getConstraintList() {
        return info.getConstraintList();
    }
    /**
     * @return
     */
    public StateMiscInfo getMisc() {
        return info.getMisc();
    }
    /**
     * @return
     */
    public UpdateListInfo getUpdateList() {
        return info.getUpdateList();
    }
    /**
     * @return
     */
    public VariableListInfo getVariableList() {
        return info.getVariableList();
    }
    /**
     * @param choiceConstraints
     */
    public void setChoiceConstraints(String choiceConstraints) {
        info.setChoiceConstraints(choiceConstraints);
    }
    /**
     * @param constraintList
     */
    public void setConstraintList(ConstraintListInfo constraintList) {
        info.setConstraintList(constraintList);
    }
    /**
     * @param misc
     */
    public void setMisc(StateMiscInfo misc) {
        info.setMisc(misc);
    }
    /**
     * @param updateList
     */
    public void setUpdateList(UpdateListInfo updateList) {
        info.setUpdateList(updateList);
    }
    /**
     * @param variableList
     */
    public void setVariableList(VariableListInfo variableList) {
        info.setVariableList(variableList);
    }
    public int getEventType() {
		return EVENT_TYPE;
	}
}