/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultChoicePointEvent extends BasicChoicePointEvent implements ChoicePointEvent, 
	StateProvider, StateEventListener,
	ChoiceConstraintListProvider, ChoiceConstraintEventListener {
    
    protected StateListenerDecoratorImpl stateDecorator;
    protected ChoiceConstraintListListenerDecoratorImpl choiceDecorator;
    
    public DefaultChoicePointEvent() {
        stateDecorator= new DefaultStateListenerDecorator(this);
        choiceDecorator= new DefaultChoiceConstraintListListenerDecorator(this);
    }
    
    public void reset() {
    	if (info != null) {
    		stateDecorator.reset();
            choiceDecorator.reset();
            super.reset();
    	}
    }
    
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    


    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }
    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }
    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }
    
    /**
     * @return
     */
    public ChoiceConstraintListInfo getChoiceConstraintList() {
        return info == null ? null : info.getChoiceConstraintList();
    }
    /**
     * @param constraintList
     */
    public void setChoiceConstraintList(ChoiceConstraintListInfo constraintList) {
        buildInfo();
        info.setChoiceConstraintList(constraintList);
    }
    /**
     * @param ev
     */
    public void eventProcess(ChoiceConstraintEvent ev) {
    	if (info != null) choiceDecorator.eventProcess(ev);
    }
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}