/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListProvider;
import fr.inria.oadymppac.parsing.info.VariablesInfo;
import fr.inria.oadymppac.parsing.info.VariablesProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultConstraintEvent extends BasicConstraintEvent implements ConstraintEvent, 
	UpdateListProvider, UpdateEventListener,
	VariablesProvider, VariablesEventListener{
    

    protected UpdateListListenerDecoratorImpl updateListDecorator;
    
   protected VariablesListenerDecoratorImpl variablesDecorator;
    
    public DefaultConstraintEvent() {
        super();
        updateListDecorator=new DefaultUpdateListListenerDecorator(this);
        variablesDecorator=new DefaultVariablesListenerDecorator(this);
        

} 
    /**
     * @param ev
     */
    public void eventProcess(UpdateEvent ev) {
    	if (info != null) updateListDecorator.eventProcess(ev);
    }

    

        /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    
    /**
     * @param updateList
     */
    public void setUpdateList(UpdateListInfo updateList) {
    	buildInfo();
         info.setUpdateList(updateList);
    }
    /**
     * @return
     */
    public UpdateListInfo getUpdateList() {
        return info == null ? null : info.getUpdateList();
    }
 
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		updateListDecorator.reset();
            variablesDecorator.reset();
            super.reset();
    	}
    } 
 
    /**
     * @param ev
     */
    public void eventProcess(VariablesEvent ev) {
    	if (info != null) variablesDecorator.eventProcess(ev);
    }
    /**
     * @return
     */
    public VariablesInfo getVariables() {
        return info == null ? null : info.getVariables();
    }
    /**
     * @param variables
     */
    public void setVariables(VariablesInfo variables) {
        buildInfo();
        info.setVariables(variables);
    }
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}