/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValueListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEventListener;
import fr.inria.oadymppac.parsing.info.CauseListInfo;
import fr.inria.oadymppac.parsing.info.CauseListProvider;
import fr.inria.oadymppac.parsing.info.ConstraintsInfo;
import fr.inria.oadymppac.parsing.info.ConstraintsProvider;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValueListProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultExplanationEvent extends BasicExplanationEvent implements ExplanationEvent, 
	ValueListProvider, RangeEventListener, ValuesEventListener,
	ConstraintsProvider, ConstraintsEventListener,
	CauseListProvider, CauseEventListener{

    protected ValueListListenerDecoratorImpl valueListDecorator;
    
    protected ConstraintsListenerDecoratorImpl constraintsDecorator;
    
    protected CauseListListenerDecoratorImpl causeListDecorator;

    public DefaultExplanationEvent() {
        super();
        valueListDecorator = new DefaultValueListListenerDecorator(this);
        constraintsDecorator = new DefaultConstraintsListenerDecorator(this);
        causeListDecorator = new DefaultCauseListListenerDecorator(this);
    }

    /**
     * @param ev
     */
    public void eventProcess(RangeEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }

    /**
     * @param ev
     */
    public void eventProcess(ValuesEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }

    public void eventProcess(ConstraintsEvent ev) {
    	if (info != null) constraintsDecorator.eventProcess(ev);
    }

    
    public void eventProcess(CauseEvent ev) {
    	if (info != null) causeListDecorator.eventProcess(ev);
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }

    /**
     * @return
     */
    public ValueListInfo getValueList() {
        return info == null ? null : info.getValueList();
    }

    /**
     * @param valueList
     */
    public void setValueList(ValueListInfo valueList) {
        buildInfo();
        info.setValueList(valueList);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
        super.reset();
        valueListDecorator.reset();
        constraintsDecorator.reset();
        causeListDecorator.reset();
    }
    
 
	/**
	 * @return Returns the constraints.
	 */
	public ConstraintsInfo getConstraints() {
		return info == null ? null : info.getConstraints();
	}
	/**
	 * @param constraints The constraints to set.
	 */
	public void setConstraints(ConstraintsInfo constraints) {
		buildInfo();
		info.setConstraints(constraints);
	}
	
	/**
     * @return
     */
    public CauseListInfo getCauseList() {
        return info == null ? null : info.getCauseList();
    }

    /**
     * @param valueList
     */
    public void setCauseList(CauseListInfo causeList) {
        buildInfo();
        info.setCauseList(causeList);
    }
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}