/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultNewConstraintEvent extends BasicNewConstraintEvent 
	implements NewConstraintEvent, UpdateListProvider, StateProvider, UpdateEventListener,StateEventListener {
 

    protected UpdateListListenerDecoratorImpl updateListDecorator;
    
    protected StateListenerDecoratorImpl stateDecorator;
    
    public DefaultNewConstraintEvent() {
        super();
        updateListDecorator=new DefaultUpdateListListenerDecorator(this);
        stateDecorator=new DefaultStateListenerDecorator(this);

} 
    /**
     * @param ev
     */
    public void eventProcess(UpdateEvent ev) {
    	if (info != null) updateListDecorator.eventProcess(ev);
    }

    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }

        /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    
    /**
     * @param updateList
     */
    public void setUpdateList(UpdateListInfo updateList) {
        buildInfo();
        info.setUpdateList(updateList);
    }
    /**
     * @return
     */
    public UpdateListInfo getUpdateList() {
        return info == null ? null : info.getUpdateList();
    }
 
    /**
     * @param updateList
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }
    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null ){
    		updateListDecorator.reset();
            stateDecorator.reset();
    		super.reset();
    	}
    }
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}