/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValueListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValueListProvider;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.parsing.info.VarDomainProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultNewVariableEvent extends BasicNewVariableEvent
									 implements NewVariableEvent, 
									 			ValueListProvider,
									 	        RangeEventListener, 
									 	        ValuesEventListener,
									 	        VarDomainProvider,
									 	        VarDomainEventListener,
									 	        StateProvider,
									 	        StateEventListener
									 {
    protected ValueListListenerDecoratorImpl valueListDecorator; 
    
    protected VarDomainListenerDecoratorImpl varDomainDecorator; 
    
    protected StateListenerDecoratorImpl stateDecorator; 
    
    
    
    public DefaultNewVariableEvent() {
        super();
        valueListDecorator = new DefaultValueListListenerDecorator(this);
        stateDecorator = new DefaultStateListenerDecorator(this);
        varDomainDecorator = new DefaultVarDomainListenerDecorator(this);
    }
    
    public void reset() {
    	if (info != null) {
    		valueListDecorator.reset();
    		varDomainDecorator.reset();
    		stateDecorator.reset();
    		super.reset();
    	}
        
    }
    

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEvent)
     */
    public void eventProcess(RangeEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableValuesEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableValuesEvent)
     */
    public void eventProcess(ValuesEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    
	   /**
     * @return
     */
    public ValueListInfo getValueList() {
        return info == null ? null : info.getValueList();
    }
    /**
     * @param valueList
     */
    public void setValueList(ValueListInfo valueList) {
        buildInfo();
        info.setValueList(valueList);
    }

    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }
    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }
    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }
    /**
     * @param ev
     */
    public void eventProcess(VarDomainEvent ev) {
    	if (info != null) varDomainDecorator.eventProcess(ev);
    }
    /**
     * @return
     */
    public VarDomainInfo getVarDomain() {
        return info == null ? null : info.getVarDomain();
    }
    /**
     * @param vardomain
     */
    public void setVarDomain(VarDomainInfo vardomain) {
        buildInfo();
        info.setVarDomain(vardomain);
    }
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}