/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 19 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.Context;
import fr.inria.oadymppac.parsing.ElementHierarchyHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideElementEvent;
import fr.inria.oadymppac.parsing.gentra4cp.handlers.*;
import fr.inria.oadymppac.parsing.info.ProvideInfo;


/**
 * @author raf
 *
 * @
 */
public class DefaultProvideElementEvent extends EventImpl implements ProvideElementEvent {

	private ProvideContentHandler provide;
	private ElementHierarchyHandler hierarchy;
	private ProvideInfo info;
	private String current;
	private int length;
	private int att;
	
	protected void buildInfo() {}
    /**
     * 
     */
    

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.parsing.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	if (logger.isDebugEnabled()) logger.info("Building a new Provide event from "+atts.toString());
    	provide = (ProvideContentHandler)handler;
    	hierarchy= provide.getHierarchyHandler();
       	info = provide.getProvideInfo();
    	if (info == null) {
    		info= provide.buildProvideInfo();
    		provide.setProvideInfo(info);
    	}
    	current = hierarchy.peek();
    	info.add(current);
    	length = atts.getLength();
    	for (att=0;att < length; att++ ) {
    		info.add(Context.compose(current,atts.getQName(att)));
    	}
    }

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.parsing.ContentHandler, char[], int, int)
     */
    public void init(ContentHandler handler, char[] ch, int start, int len) {

    }

  
 
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}
