/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.DeltaInfo;
import fr.inria.oadymppac.parsing.info.DeltaProvider;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.UpdateProvider;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.parsing.info.VarDomainProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultReduceEvent extends  BasicReduceEvent implements ReduceEvent,
	 UpdateProvider, UpdateEventListener, 
	 StateProvider, StateEventListener,
	 VarDomainProvider, VarDomainEventListener,
	 DeltaProvider, DeltaEventListener {
    
    protected StateListenerDecoratorImpl stateDecorator;

    protected UpdateListenerDecoratorImpl updateDecorator;
    
    protected VarDomainListenerDecoratorImpl varDomainDecorator;
    
    protected DeltaListenerDecoratorImpl deltaDecorator;
    
    public DefaultReduceEvent() {
        super();
        updateDecorator = new DefaultUpdateListenerDecorator(this);
        varDomainDecorator = new DefaultVarDomainListenerDecorator(this);
        deltaDecorator =   new DefaultDeltaListenerDecorator(this);
        stateDecorator= new DefaultStateListenerDecorator(this);
    }
     
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }
 
    
    
    /**
     * @param ev
     */
    public void eventProcess(UpdateEvent ev) {
    	if (info != null) updateDecorator.eventProcess(ev);
    }
    


    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }



    /**
     * @return
     */
    public UpdateInfo getUpdate() {
        return info == null ? null : info.getUpdate();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
        updateDecorator.reset();
        varDomainDecorator.reset();
        deltaDecorator.reset();
        stateDecorator.reset();
        super.reset();
    	}
    }
    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }



    /**
     * @param update
     */
    public void setUpdate(UpdateInfo update) {
        info.setUpdate(update);
    }
    /**
     * @param ev
     */
    public void eventProcess(DeltaEvent ev) {
        if (info != null) deltaDecorator.eventProcess(ev);
    }
    /**
     * @return
     */
    public DeltaInfo getDelta() {
        return info == null ? null : info.getDelta();
    }
    /**
     * @param delta
     */
    public void setDelta(DeltaInfo delta) {
        buildInfo();
        info.setDelta(delta);
    }
    /**
     * @param ev
     */
    public void eventProcess(VarDomainEvent ev) {
    	if (info != null) varDomainDecorator.eventProcess(ev);
    }
    /**
     * @return
     */
    public VarDomainInfo getVarDomain() {
        return info == null ? null : info.getVarDomain();
    }
    /**
     * @param vardomain
     */
    public void setVarDomain(VarDomainInfo vardomain) {
        buildInfo();
        info.setVarDomain(vardomain);
    }
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}