/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.UpdateProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultScheduleEvent extends BasicScheduleEvent implements ScheduleEvent,  UpdateProvider, UpdateEventListener, StateProvider, StateEventListener {
    protected StateListenerDecoratorImpl stateDecorator;
    protected UpdateListenerDecoratorImpl  updateDecorator;
    
    public DefaultScheduleEvent() {
        updateDecorator =new DefaultUpdateListenerDecorator(this);
        stateDecorator= new DefaultStateListenerDecorator(this);
    }
    
    
 
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }
    
  
    /**
     * @param ev
     */
    public void eventProcess(UpdateEvent ev) {
    	if (info != null) updateDecorator.eventProcess(ev);
    }
    


    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }


    /**
     * @return
     */
    public UpdateInfo getUpdate() {
        return info == null ? null : info.getUpdate();
    }
    
    public void reset() {
    	if (info != null) {
        
        updateDecorator.reset();
        stateDecorator.reset();
        super.reset();
        }
    }
    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }


    /**
     * @param update
     */
    public void setUpdate(UpdateInfo update) {
        buildInfo();
        info.setUpdate(update);
    }
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}