/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateRangeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateRangeEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateValuesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateValuesEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValueListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEvent;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValueListProvider;

/**
 * @author raf
 *  @
 */
public class DefaultUpdateEvent extends BasicUpdateEvent implements
        UpdateEvent,  ValueListProvider, UpdateRangeEventListener, UpdateValuesEventListener {

    protected ValueListListenerDecoratorImpl valueListDecorator;

    public DefaultUpdateEvent() {
        super();
        valueListDecorator = new DefaultValueListListenerDecorator(this);
    }

    /**
     * @param ev
     */
    public void eventProcess(RangeEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }

    /**
     * @param ev
     */
    public void eventProcess(ValuesEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.UpdateRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.UpdateRangeEvent)
     */
    public void eventProcess(UpdateRangeEvent ev) {
    	if (info != null) valueListDecorator.eventProcess(ev);

    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.UpdateValuesEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.UpdateValuesEvent)
     */
    public void eventProcess(UpdateValuesEvent ev) {
    	if (info != null)  valueListDecorator.eventProcess(ev);

    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }

    /**
     * @return
     */
    public ValueListInfo getValueList() {
        return info == null ? null : info.getValueList();
    }

    /**
     * @param valueList
     */
    public void setValueList(ValueListInfo valueList) {
    	buildInfo();
        info.setValueList(valueList);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {	
    		valueListDecorator.reset();
    		super.reset();
    	}
    }
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}