/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.CauseInfo;
import fr.inria.oadymppac.parsing.info.CauseListInfo;
import fr.inria.oadymppac.parsing.info.CauseListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class CauseListListenerDecoratorImpl extends InfoDecoratorImpl implements CauseListListenerDecorator, CauseListProvider {

    protected CauseListInfo info;
    protected CauseListProvider provider;
    
    /**
     * @param ev
     */
    public CauseListListenerDecoratorImpl(CauseListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewCauseRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewCauseRangeEvent)
	 */
	public void eventProcess(CauseEvent ev) {
		Event.logger.info("Cause Domain event "+ev);
		if (provider.getCauseList() == null) {
            info =new CauseListInfo();
            provider.setCauseList(info);
        }else {
            info = provider.getCauseList();
        }
		try {
		    CauseInfo current = (CauseInfo)ev.getInfo();
		    if (current != null) add((CauseInfo)current.clone());
		   // ev.reset();
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Cause",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Cause",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		info.clear();
    		super.reset();
    	}
    }
    

  
    /**
     * @return Returns the info.
     */
    public CauseListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(CauseListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(CauseInfo update) {
        if (info == null) info = new CauseListInfo();
        return info.add(update);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(CauseInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   

    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.CauseListProvider#getCauseList()
     */
    public CauseListInfo getCauseList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.CauseListProvider#setCauseList(fr.inria.oadymppac.parsing.info.CauseListInfo)
     */
    public void setCauseList(CauseListInfo causeList) {
       this.info=causeList;

    }
}
