/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.DeltaInfo;
import fr.inria.oadymppac.parsing.info.DeltaListInfo;
import fr.inria.oadymppac.parsing.info.DeltaListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class DeltaListListenerDecoratorImpl extends InfoDecoratorImpl implements DeltaListListenerDecorator, DeltaListProvider {

    protected DeltaListInfo info;
    protected DeltaListProvider provider;
    
    /**
     * @param ev
     */
    public DeltaListListenerDecoratorImpl(DeltaListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEvent)
	 */
	public void eventProcess(DeltaEvent ev) {
		Event.logger.info("Delta Domain event "+ev);
		if (provider.getDeltaList() == null) {
            info =new DeltaListInfo();
            System.out.println("creation of a DeltaList"); 
            provider.setDeltaList(info);
        }else {
            info = provider.getDeltaList();
        }
		try {
		    DeltaInfo current = (DeltaInfo)ev.getInfo();
		    if (current != null) add((DeltaInfo)current.clone());
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Delta",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Delta",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info !=null) {
    		info.clear();
    		super.reset();
    	}
    }
    

  
    /**
     * @return Returns the info.
     */
    public DeltaListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(DeltaListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(DeltaInfo delta) {
        if (info == null) info = new DeltaListInfo();
        return info.add(delta);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(DeltaInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#terminate()
     */

    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.DeltaListProvider#getDeltaList()
     */
    public DeltaListInfo getDeltaList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.DeltaListProvider#setDeltaList(fr.inria.oadymppac.parsing.info.DeltaListInfo)
     */
    public void setDeltaList(DeltaListInfo deltaList) {
       this.info=deltaList;

    }
}
