/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.VariableInfo;
import fr.inria.oadymppac.parsing.info.VariableListInfo;
import fr.inria.oadymppac.parsing.info.VariableListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class VariableListListenerDecoratorImpl extends InfoDecoratorImpl implements VariableListListenerDecorator, VariableListProvider {

    protected VariableListInfo info;
    protected VariableListProvider provider;
    
    /**
     * @param ev
     */
    public VariableListListenerDecoratorImpl(VariableListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEvent)
	 */
	public void eventProcess(VariableEvent ev) {
		Event.logger.info("Variable Domain event "+ev);
		if (provider.getVariableList() == null) {
            info =new VariableListInfo();
            provider.setVariableList(info);
        }else {
            info = provider.getVariableList();
        }
		try {
		    VariableInfo current = (VariableInfo)ev.getInfo();
		    if (current != null) add((VariableInfo)current.clone());
		   // ev.reset();
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Variable",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Variable",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		info.clear();
    		super.reset();
    	}
    }
    

  
    /**
     * @return Returns the info.
     */
    public VariableListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(VariableListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(VariableInfo update) {
        if (info == null) info = new VariableListInfo();
        return info.add(update);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(VariableInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#terminate()
     */
 /*   public void terminate() {
        super.terminate();
        if (logger.isDebugEnabled()) logger.info("Updating VariableListProvider by setting VariableList into "+provider+" via "+this);
        try {
            provider.setVariableList((VariableListInfo)info.clone());
        } catch (ClassCastException cst) {
            logger.error("Impossible to cast event into VariableListProvider",cst);
        } catch (CloneNotSupportedException cln) {
            logger.error("Impossible to clone the updateList",cln);
        }
    }
  
*/
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.VariableListProvider#getVariableList()
     */
    public VariableListInfo getVariableList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.VariableListProvider#setVariableList(fr.inria.oadymppac.parsing.info.VariableListInfo)
     */
    public void setVariableList(VariableListInfo variableList) {
       this.info=variableList;

    }
}
