/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 16 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.parsing.event.EventListenerManagerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateMiscEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ChecksumEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ContributorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.CreatorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DescriptionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.IdentifierEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ParametersEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.RightsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SolverEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SourceEvent;

/**
 * @author raf
 *
 * @
 */
public class CopyOfFasterEventListenerManager extends EventListenerManagerImpl {
	Class lc;
	Method method;
	Class[] sign = new Class[1];
    public void fireEvent(Event e) {
        EventListener[] lList = getListeners(e); // not a very efficient implementation !
        int t=e.getEventType();
        System.out.println("#Listeners:" +lList.length+" Event Type:"+t );
        switch (t) {
        	case AnnotationCommandEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((AnnotationCommandEvent) e);
        		break;
        	case AnnotationEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((AnnotationEvent) e);
        		break;
        	case AwakeEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((AwakeEvent) e);
        		break;
        	case BackToEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((BackToEvent) e);
        		break;	
        	case CauseEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((CauseEvent) e);
        		break;	
        	case ChoiceConstraintEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ChoiceConstraintEvent) e);
        		break;	
        	case ConstraintEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ConstraintEvent) e);
        		break;	
        	case ConstraintsEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ConstraintsEvent) e);
        		break;	
        	case DeltaEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((DeltaEvent) e);
        		break;	
        	case EndStageEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((EndStageEvent) e);
        		break;	
        	case ExplanationEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ExplanationEvent) e);
        		break;	
        	case FailureEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((FailureEvent) e);
        		break;	
        	case NewConstraintEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((NewConstraintEvent) e);
        		break;	
        	case NewStageEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((NewStageEvent) e);
        		break;	
        	case NewVariableEvent.EVENT_TYPE:
        		sign[0] = NewVariableEvent.class;
        		break;	
        	case PostEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((PostEvent) e);
        		break;	
        	case ReduceEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ReduceEvent) e);
        		break;	
        	case RejectEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((RejectEvent) e);
        		break;	
        	case RemoveEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((RemoveEvent) e);
        		break;	
        	case RestoreEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((RestoreEvent) e);
        		break;	
        	case ResumeStageEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ResumeStageEvent) e);
        		break;	
        	case ScheduleEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ScheduleEvent) e);
        		break;	
        	case SolutionEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SolutionEvent) e);
        		break;	
        	case SolvedEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SolvedEvent) e);
        		break;	
        	case StageCommentEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((StageCommentEvent) e);
        		break;	
        	case StartStageEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((StartStageEvent) e);
        		break;	
        	case StateEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((StateEvent) e);
        		break;	
        	case StateMiscEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((StateMiscEvent) e);
        		break;	
        	case SuspendEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SuspendEvent) e);
        		break;	
        	case SuspendStageEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SuspendStageEvent) e);
        		break;	
        	case UpdateEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((UpdateEvent) e);
        		break;	
        	case VarDomainEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((VarDomainEvent) e);
        		break;	
        	case VariableEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((VariableEvent) e);
        		break;	
        	case VariablesEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((VariablesEvent) e);
        		break;	
        	case ChecksumEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ChecksumEvent) e);
        		break;	
        	case ContributorEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ContributorEvent) e);
        		break;	
        	case CreatorEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((CreatorEvent) e);
        		break;	
        	case DateEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((DateEvent) e);
        		break;	
        	case DescriptionEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((DescriptionEvent) e);
        		break;	
        	case IdentifierEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((IdentifierEvent) e);
        		break;	
        	case ParametersEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((ParametersEvent) e);
        		break;	
        	case RightsEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((RightsEvent) e);
        		break;	
           	case SolverEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SolverEvent) e);
        		break;	
           	case SourceEvent.EVENT_TYPE:
        		for(int i=0; i < lList.length; i++) lList[i].eventProcess((SourceEvent) e);
        		break;	

        	default :
        		if (logger.isDebugEnabled()) logger.error("Event not fired because not recognized"+e);
        		break;
        }
        for(int i=0; i < lList.length; i++) {
        	System.out.println("Event:"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
        	lc = lList[i].getClass();	
        	try {    
        		Method m= lc.getMethod("eventProcess", sign);
        		Object[] param = {e};
        		m.invoke(lList[i],param);
        	} catch (IllegalArgumentException arg) {
        		logger.error("Event listener does not listen this class of event ",arg);
        	} catch (IllegalAccessException acc) {
        		logger.error("Listener is not publically handling this event ",acc);
        	} catch (InvocationTargetException trg) {
        		logger.error("Target "+ trg.getMessage()+ " is inaccessible ",trg);
        	} catch (SecurityException sec) {
        		logger.error("Security "+ sec.getMessage()+ " problem invoking method",sec);
        	} catch (NoSuchMethodException nsm) {
        		logger.error("Methode "+ nsm.getMessage()+ " is not implemented",nsm);
        	}
        }
    }
    
}
