/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 16 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.parsing.event.EventListenerManagerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ConstraintsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PacketEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideElementEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RangeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateMiscEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.UpdateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ValuesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ChecksumEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ContributorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.CreatorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DescriptionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.IdentifierEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ParametersEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.RightsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SolverEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SourceEvent;

/**
 * @author raf
 *
 * @
 */
public class FasterEventListenerManager extends EventListenerManagerImpl {

	EventListener[] lList;
	Class lc;
	Method method;
	Class[] sign = new Class[1];
	Object[] param = new Object[1];
	
	protected Class[] mapping;
	
	
	protected Class[] buildDefaultMapping() {
		Class[] result = new Class[55];	
    	result[AnnotationCommandEvent.EVENT_TYPE]=AnnotationCommandEvent.class;
    	result[AnnotationEvent.EVENT_TYPE]=AnnotationEvent.class;
    	result[AwakeEvent.EVENT_TYPE]=AwakeEvent.class;
    	result[BackToEvent.EVENT_TYPE]=BackToEvent.class;
    	result[CauseEvent.EVENT_TYPE]=CauseEvent.class;
    	result[ChoiceConstraintEvent.EVENT_TYPE]=ChoiceConstraintEvent.class;
    	result[ChoicePointEvent.EVENT_TYPE]=ChoicePointEvent.class;
    	result[ConstraintEvent.EVENT_TYPE]=ConstraintEvent.class;
    	result[ConstraintsEvent.EVENT_TYPE]=ConstraintsEvent.class;
    	result[DeltaEvent.EVENT_TYPE]=DeltaEvent.class;
    	result[EndStageEvent.EVENT_TYPE]=EndStageEvent.class;
    	result[ExplanationEvent.EVENT_TYPE]=ExplanationEvent.class;
    	result[FailureEvent.EVENT_TYPE]=FailureEvent.class;
    	result[NewConstraintEvent.EVENT_TYPE]=NewConstraintEvent.class;
    	result[NewStageEvent.EVENT_TYPE]=NewStageEvent.class;
    	result[NewVariableEvent.EVENT_TYPE] = NewVariableEvent.class;
    	result[PacketEvent.EVENT_TYPE]=PacketEvent.class;
    	result[PostEvent.EVENT_TYPE]=PostEvent.class;
    	result[ProvideElementEvent.EVENT_TYPE]=ProvideElementEvent.class;
    	result[ProvideEvent.EVENT_TYPE]=ProvideEvent.class;
    	result[RangeEvent.EVENT_TYPE]=RangeEvent.class;
    	result[ReduceEvent.EVENT_TYPE]=ReduceEvent.class;
    	result[RejectEvent.EVENT_TYPE]=RejectEvent.class;
    	result[RemoveEvent.EVENT_TYPE]=RemoveEvent.class;
    	result[RestoreEvent.EVENT_TYPE]=RestoreEvent.class;
    	result[ResumeStageEvent.EVENT_TYPE]=ResumeStageEvent.class;
    	result[ScheduleEvent.EVENT_TYPE]=ScheduleEvent.class;
    	result[SolutionEvent.EVENT_TYPE]=SolutionEvent.class;
    	result[SolvedEvent.EVENT_TYPE]=SolvedEvent.class;
    	result[StageCommentEvent.EVENT_TYPE]=StageCommentEvent.class;
    	result[StartStageEvent.EVENT_TYPE]=StartStageEvent.class;
    	result[StateEvent.EVENT_TYPE]=StateEvent.class;
    	result[StateMiscEvent.EVENT_TYPE]=StateMiscEvent.class;
    	result[SuspendEvent.EVENT_TYPE]=SuspendEvent.class;
    	result[SuspendStageEvent.EVENT_TYPE]=SuspendStageEvent.class;
    	result[UpdateEvent.EVENT_TYPE]=UpdateEvent.class;
    	result[ValuesEvent.EVENT_TYPE]=ValuesEvent.class;
    	result[VarDomainEvent.EVENT_TYPE]=VarDomainEvent.class;
    	result[VariableEvent.EVENT_TYPE]=VariableEvent.class;
    	result[VariablesEvent.EVENT_TYPE]=VariablesEvent.class;
    	result[ChecksumEvent.EVENT_TYPE]=ChecksumEvent.class;
    	result[ContributorEvent.EVENT_TYPE]=ContributorEvent.class;
    	result[CreatorEvent.EVENT_TYPE]=CreatorEvent.class;
    	result[DateEvent.EVENT_TYPE]=DateEvent.class;
    	result[DescriptionEvent.EVENT_TYPE]=DescriptionEvent.class;
    	result[IdentifierEvent.EVENT_TYPE]=IdentifierEvent.class;
    	result[ParametersEvent.EVENT_TYPE]=ParametersEvent.class;	
    	result[RightsEvent.EVENT_TYPE]=RightsEvent.class;	
       	result[SolverEvent.EVENT_TYPE]=SolverEvent.class;	
       	result[SourceEvent.EVENT_TYPE]=SourceEvent.class;
		return result;
    }

	
	
	
	
	
	public void fireEvent(Event e) {
		lList = getListeners(e.getClass()); 
		if (lList != null) {
			int t=e.getEventType();
			if (mapping == null) mapping = buildDefaultMapping();
			sign[0] = (t < mapping.length ? mapping[t] : null);
			if (sign[0] == null) {
				if (logger.isDebugEnabled()) logger.warn("Event not fired because not recognized"+e);
			} else {
				for(int i=0; i <lList.length ; i++) {
					lc = lList[i].getClass();	
					try {    
						method = lc.getMethod("eventProcess", sign);
						param[0] = e;
						method.invoke(lList[i],param);
						param[0] =null;				
					} catch (IllegalArgumentException arg) {
						logger.error("Event("+t+"):"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
						logger.error("Event listener does not listen this class of event ",arg);
					} catch (IllegalAccessException acc) {
						logger.error("Event("+t+"):"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
						logger.error("Listener is not publically handling this event ",acc);
					} catch (InvocationTargetException trg) {
						logger.error("Event("+t+"):"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
						logger.error("Target "+ trg.getMessage()+ " is inaccessible ",trg);
					} catch (SecurityException sec) {
						logger.error("Event("+t+"):"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
						logger.error("Security "+ sec.getMessage()+ " problem invoking method",sec);
					} catch (NoSuchMethodException nsm) {
						logger.error("Event("+t+"):"+e+" Listener:"+lList[i]+" Signature:"+sign[0]);
						logger.error("Method "+ nsm.getMessage()+ " is not implemented",nsm);
					} finally {
						
					}
				}
				lList =null;
				e.reset();
			}
		} else {
			logger.warn("No listener for the event"+e);
		}
	}
    
	/**
	 * 
	 */
	public FasterEventListenerManager() {
		System.out.println("CREATING A FASTER EVENT LISTENER !!!!");
	}
}
