/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
            	COSYTEC
*		    	4 rue Jean Rostand
* 				91893 Orsay Cedex, France
*				Tel. +33 1 60 19 37 38
*				Fax. +33 1 60 19 36 20
*
* Purpose	: COMPLETE HERE
 * 
 * Created on 9 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import org.xml.sax.SAXException;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.ContentHandlerImpl;
import fr.inria.oadymppac.parsing.DefaultElementHandler;
import fr.inria.oadymppac.parsing.event.DefaultEventListenerManager;
import fr.inria.oadymppac.parsing.event.ElementEventHandler;
import fr.inria.oadymppac.parsing.event.EventListenerManager;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultProvideElementEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultProvideEvent;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDAnnotationElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDAwakeElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDBackToElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDBreakPointElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDCauseElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDChoicePointElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDConstraintElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDConstraintListElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDConstraintsElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDEndStageElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDExplanationElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDFailureElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDNewConstraintElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDNewStageElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDNewVariableElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDPostElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDProvideElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDRangeElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDReduceElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDRejectElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDRemoveElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDRestoreElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDResumeStageElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDScheduleElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDSolutionElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDSolvedElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDStartStageElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDStateElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDSuspendElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDSuspendStageElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDUpdateElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDUpdateListElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDValuesElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDVariableElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDVariableListElement;
import fr.inria.oadymppac.parsing.info.ProvideInfo;
import fr.inria.oadymppac.parsing.info.ProvideInfoHandler;


/**
 * @author raf
 *
 * @
 */
public class ProvideContentHandler extends ContentHandlerImpl implements  ProvideInfoHandler{

    
    
    protected ProvideInfo provide;
    
  
    
    public ProvideContentHandler() {
        super();
        try {
        	addElement(DTDAnnotationElement.ANNOTATION, DefaultProvideElementEvent.class);
            addElement(DTDAwakeElement.AWAKE, DefaultProvideElementEvent.class);
            addElement(DTDBackToElement.BACKTO, DefaultProvideElementEvent.class);
            addElement(DTDBreakPointElement.BREAKPOINT, DefaultProvideElementEvent.class);
            addElement(DTDCauseElement.CAUSE, DefaultProvideElementEvent.class);
            addElement(DTDChoicePointElement.CHOICEPOINT, DefaultProvideElementEvent.class);
            addElement(DTDConstraintElement.CONSTRAINT, DefaultProvideElementEvent.class);
            addElement(DTDConstraintListElement.CONSTRAINT, DefaultProvideElementEvent.class);
            addElement(DTDConstraintsElement.CONSTRAINTS, DefaultProvideElementEvent.class);
            addElement(DTDEndStageElement.END, DefaultProvideElementEvent.class);
            addElement(DTDExplanationElement.EXPLANATION, DefaultProvideElementEvent.class);
            addElement(DTDFailureElement.FAILURE, DefaultProvideElementEvent.class);
            addElement(DTDNewConstraintElement.NEWCONSTRAINT, DefaultProvideElementEvent.class);
            addElement(DTDNewStageElement.NEWSTAGE, DefaultProvideElementEvent.class);
            addElement(DTDNewVariableElement.NEWVARIABLE, DefaultProvideElementEvent.class);
            addElement(DTDPostElement.POST, DefaultProvideElementEvent.class);
            addElement(DTDRangeElement.RANGE, DefaultProvideElementEvent.class);
            addElement(DTDReduceElement.REDUCE, DefaultProvideElementEvent.class);
            addElement(DTDRejectElement.REJECT, DefaultProvideElementEvent.class);
            addElement(DTDRemoveElement.REMOVE, DefaultProvideElementEvent.class);
            addElement(DTDRestoreElement.RESTORE, DefaultProvideElementEvent.class);
            addElement(DTDResumeStageElement.RESUME, DefaultProvideElementEvent.class);
            addElement(DTDScheduleElement.SCHEDULE, DefaultProvideElementEvent.class);
            addElement(DTDSolutionElement.SOLUTION, DefaultProvideElementEvent.class);
            addElement(DTDSolvedElement.SOLVED, DefaultProvideElementEvent.class);
            addElement(DTDStartStageElement.START, DefaultProvideElementEvent.class);
            addElement(DTDStateElement.STATE, DefaultProvideElementEvent.class);
            addElement(DTDSuspendElement.SUSPEND, DefaultProvideElementEvent.class);
            addElement(DTDSuspendStageElement.SUSPEND, DefaultProvideElementEvent.class);
            addElement(DTDUpdateElement.UPDATE, DefaultProvideElementEvent.class);            
            addElement(DTDUpdateListElement.UPDATE, DefaultProvideElementEvent.class);            
            addElement(DTDValuesElement.VALUES, DefaultProvideElementEvent.class);            
            addElement(DTDVariableElement.VARIABLE, DefaultProvideElementEvent.class);
            addElement(DTDVariableListElement.VARIABLE, DefaultProvideElementEvent.class);
            
            addElement(DTDProvideElement.PROVIDE, DefaultProvideEvent.class);
            
        } catch (ClassNotFoundException e) {
            ContentHandler.logger.error("Impossible to find class of Event",e);
        } catch (InstantiationException e) {
            ContentHandler.logger.error("Impossible to generate a new instance of Event",e);
        } catch (IllegalAccessException e) {
            ContentHandler.logger.error("Illegal method call to generate a new instance of Event",e);
        }
     }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.ContentHandler#buildElementHandler()
     */
    public ElementEventHandler buildElementHandler() {
        return new DefaultElementHandler(this);
    }    
    
    public EventListenerManager buildListenerManager() {
        return new DefaultEventListenerManager();
     }

    
    
	/* (non-Javadoc)
	 * @see org.xml.sax.ContentHandler#characters(char[], int, int)
	 */
	public void characters(char[] ch, int start, int length)
			throws SAXException {
			if (ContentHandler.logger.isDebugEnabled()) ContentHandler.logger.warn("Characters found"+String.copyValueOf(ch,start,length));
	}

	
	
	/*
     * (non-Javadoc)
     * 
     * @see org.xml.sax.ContentHandler#endElement(java.lang.String,
     *      java.lang.String, java.lang.String)
     */
 /*   public void endElement(String namespaceURI, String localName, String qName)
            throws SAXException {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("endElement(" + namespaceURI + ", "
                        + localName + ", " + qName + ")");
        if (isDelegating()) {
            delegateHandler.endElement(namespaceURI, localName, qName);
            if (qName.equals(delegateElement)) {
                if (ContentHandler.logger.isDebugEnabled())
                        ContentHandler.logger.info("Stop delegation of"
                                + delegateElement);
                delegateElement = null;
                delegateHandler = null;
            }
        } else {
            currentElementHandler = (elementMap == null ? null
                    : (ElementEventHandler) elementMap.get(qName.intern()));
            if (currentElementHandler != null) {
                EventListenerManager.logger
                        .info("End Element FIRING event for " + qName.intern()
                                + "(" + currentElementHandler + ")");
                currentElementHandler.updateDepth(-1);
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
                    if (EventListenerManager.logger.isDebugEnabled())
                            EventListenerManager.logger.info("Firing Event "
                                    + currentEvent);
                    fireEvent(currentEvent);                     
                }
                
                EventListenerManager.logger.info("All events fired");
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
                    if (ContentHandler.logger.isDebugEnabled())
                            ContentHandler.logger.info("Resetting Event "
                                    + currentEvent);
                    currentEvent.reset();
                }
                EventListenerManager.logger.info("All events reset");                
                currentElementHandler = null;
            }
        }
    }
   */ 
    /*
     * (non-Javadoc)
     * 
     * @see org.xml.sax.ContentHandler#startElement(java.lang.String,
     *      java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
/*    public void startElement(String namespaceURI, String localName,
            String qName, Attributes atts) throws SAXException {
        if (ContentHandler.logger.isDebugEnabled())
                ContentHandler.logger.info("startElement(" + namespaceURI
                        + ", " + localName + ", " + qName + ", " + atts + ")");
        if (isDelegating()) {
            ContentHandler.logger.info("Keep on delegating");
            delegateHandler.startElement(namespaceURI, localName, qName, atts);
        } else {
       	
            currentElementHandler = (elementMap == null ? null
                    : (ElementEventHandler) elementMap.get(qName.intern()));
            if (currentElementHandler != null) {
                ContentHandler.logger.info("Element Handler found");
                currentElementHandler.updateCount();
                currentElementHandler.updateDepth(+1);
                currentIterator = currentElementHandler.getEvents().iterator();
                while (currentIterator != null && currentIterator.hasNext()) {
                    currentEvent = (Event) currentIterator.next();
                    if (ContentHandler.logger.isDebugEnabled())
                            ContentHandler.logger.info("Building Event "
                                    + currentEvent);
                    currentEvent.init(this, atts);
                }
                ContentHandler.logger.info("All events generated");
            } else {
                delegateHandler = (delegateMap == null ? null
                        : (ContentHandler) delegateMap.get(qName.intern()));
                if (delegateHandler != null) {
                    ContentHandler.logger.info("Element delegation found");
                    delegateElement = qName.intern();
                    ContentHandler.logger.info("Start delegating");
                    delegateHandler.startElement(namespaceURI, localName,
                            qName, atts);
                } else {
                    ContentHandler.logger.warn("Element must be ignored");
                }
            }
        }
    }
*/
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.ProvideInfoHandler#buildProvideInfo()
	 */
	public ProvideInfo buildProvideInfo() {
		return new ProvideInfo();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.ProvideInfoHandler#getProvideInfo()
	 */
	public ProvideInfo getProvideInfo() {
		return provide;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.ProvideInfoHandler#setProvideInfo(fr.inria.oadymppac.solver.ProvideInfo)
	 */
	public void setProvideInfo(ProvideInfo info) {
		this.provide=info;
	}
}
