/*
 * Created on 25 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.parsing.event.NoneEvent;
import fr.inria.oadymppac.parsing.gentra4cp.ControlContentHandler;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultBreakPointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultChecksumEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultComplementEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultContributorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultCreatorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultDateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultDescriptionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultPacketEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultParametersEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultProvideEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultRightsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultSolverEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultSourceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.HeadEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDBreakPointElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDComplementElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDGenTra4CPElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDHeadElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDPacketElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDProvideElement;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEventListener;
import fr.inria.oadymppac.parsing.info.ProvideInfo;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class TraceContentHandler extends TopLevelContentHandler {
    HeadContentHandler headHandler;
    ProvideContentHandler provideHandler;
    ControlContentHandler controlHandler;
    ComplementContentHandler complementHandler;
    
    

    public TraceContentHandler() {
        super();
        headHandler = new HeadContentHandler();
        provideHandler = new ProvideContentHandler();
        controlHandler = new ControlContentHandler();
        complementHandler = new ComplementContentHandler();
 
 
        
    }
    
    public void addDefaultListener(EventListener solverListener) {
            addDelegateHandler(DTDHeadElement.HEAD,headHandler);
            addDelegateHandler(DTDProvideElement.PROVIDE,provideHandler);
            addDelegateHandler(DTDPacketElement.PACKET, controlHandler);
            addDelegateHandler(DTDBreakPointElement.BREAKPOINT, controlHandler);
            addDelegateHandler(DTDComplementElement.COMPLEMENT, complementHandler);
            try {
                addElement(DTDGenTra4CPElement.GENTRA4CP,NoneEvent.class); 
                addContextOffset(DTDGenTra4CPElement.GENTRA4CP);
            } catch (ClassNotFoundException e) {
                ContentHandler.logger.error("Impossible to find class of Event",e);
            } catch (InstantiationException e) {
                ContentHandler.logger.error("Impossible to generate a new instance of Event",e);
            } catch (IllegalAccessException e) {
                ContentHandler.logger.error("Illegal method call to generate a new instance of Event",e);
            } catch (Exception e) {
                ContentHandler.logger.error("Undetermined Exception",e);
            }
            
            super.addDefaultListener(solverListener);
            controlHandler.addDefaultListener(solverListener);
            complementHandler.addDefaultListener(solverListener);
    }
        

 
    
    
    public void addHeadListener(HeadEventListener headListener) {
        headHandler.addListener(DefaultDateEvent.class,headListener );
        headHandler.addListener(DefaultSourceEvent.class,headListener );
        headHandler.addListener(DefaultCreatorEvent.class,headListener );
        headHandler.addListener(DefaultContributorEvent.class,headListener );
        headHandler.addListener(DefaultDescriptionEvent.class,headListener );
        headHandler.addListener(DefaultRightsEvent.class,headListener );
        headHandler.addListener(DefaultSolverEvent.class,headListener );
        headHandler.addListener(DefaultParametersEvent.class,headListener );
        headHandler.addListener(DefaultChecksumEvent.class,headListener ); 
        controlHandler.addHeadListener(headListener);
    }
    
    public ProvideInfo getHeadProvideInfo() {
        return headHandler.getProvideInfo();
    }

    /**
     * @param providableListener
     */
    public void addProvidableListener(ProvideEventListener providableListener) {
        headHandler.getProvide().addListener(DefaultProvideEvent.class, providableListener);
        controlHandler.addProvidableListener(providableListener);
    }

    /**
     * @param providedListener
     */
    public void addProvidedListener(ProvideEventListener providedListener) {
        provideHandler.addListener(DefaultProvideEvent.class, providedListener);
        controlHandler.addProvidedListener(providedListener);
    }
    
    /**
     * @param providableListener
     */
    public void addControlListener(EventListener listener) {
        controlHandler.addListener(DefaultBreakPointEvent.class, listener);
        controlHandler.addListener(DefaultPacketEvent.class, listener);
    }
    
    public void addComplementListener(EventListener listener) {
        complementHandler.addListener(DefaultComplementEvent.class, listener);
        controlHandler.addComplementListener(listener);
    }
	/**
	 * @return Returns the complementHandler.
	 */
	public ComplementContentHandler getComplementHandler() {
		return complementHandler;
	}
	/**
	 * @param complementHandler The complementHandler to set.
	 */
	public void setComplementHandler(ComplementContentHandler complementHandler) {
		this.complementHandler = complementHandler;
	}
	/**
	 * @return Returns the controlHandler.
	 */
	public ControlContentHandler getControlHandler() {
		return controlHandler;
	}
	/**
	 * @param controlHandler The controlHandler to set.
	 */
	public void setControlHandler(ControlContentHandler controlHandler) {
		this.controlHandler = controlHandler;
	}
	/**
	 * @return Returns the headHandler.
	 */
	public HeadContentHandler getHeadHandler() {
		return headHandler;
	}
	/**
	 * @param headHandler The headHandler to set.
	 */
	public void setHeadHandler(HeadContentHandler headHandler) {
		this.headHandler = headHandler;
	}
	/**
	 * @return Returns the provideHandler.
	 */
	public ProvideContentHandler getProvideHandler() {
		return provideHandler;
	}
	/**
	 * @param provideHandler The provideHandler to set.
	 */
	public void setProvideHandler(ProvideContentHandler provideHandler) {
		this.provideHandler = provideHandler;
	}
}
