/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.NewConstraintAttributes;


/**
 * @author raf
 *
 * @
 */
public class NewConstraintInfo extends EventInfo implements NewConstraintAttributes, UpdateListProvider,StateProvider, Cloneable {
	public static final int INFO_TYPE = 19;
	public  int getInfoType() {
		return INFO_TYPE;
	}
	
	protected String identifier;
    protected String name;
    protected String external;
    protected String internal;
    protected String origin;
    
    protected UpdateListInfo updateList;
    
    protected StateInfo state;
    
    private String buffer;
    
    
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getExternalRepresentation()
     */
    public String getExternal() {
        return external;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getIdentifier()
     */
    public String getIdentifier() {
        return identifier;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getInternalRepresentation()
     */
    public String getInternal() {
        return internal;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getName()
     */
    public String getName() {
        return name;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setExternalRepresentation(java.lang.String)
     */
    public void setExternal(String external) {
        this.external=external;
        
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setIdentifier(java.lang.String)
     */
    public void setIdentifier(String ident) {
        this.identifier=ident;
        
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setInternalRepresentation(java.lang.String)
     */
    public void setInternal(String internal) {
        this.internal=internal;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setName(java.lang.String)
     */
    public void setName(String name) {
        this.name=name;
    }
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#getOrigin()
	 */
	public String getOrigin() {
		return origin;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setOrigin(String orig) {
		this.origin=orig;
	}

 

    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.BasicInfo#clone()
     */
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        NewConstraintInfo clone = new NewConstraintInfo();
        clone(clone);
        clone.setIdentifier(identifier);
        clone.setName(name);
        clone.setInternal(internal);
        clone.setExternal(external);
        clone.setOrigin(origin);
        if (updateList != null) clone.setUpdateList((UpdateListInfo)updateList.clone());
        if(state != null) clone.setState((StateInfo) state.clone());
        return clone;
    }


    /**
     * @return Returns the updateList.
     */
    public UpdateListInfo getUpdateList() {
        return updateList;
    }
    /**
     * @param updateList The updateList to set.
     */
    public void setUpdateList(UpdateListInfo updateList) {
        this.updateList = updateList;
    }
    /**
     * @return Returns the state.
     */
    public StateInfo getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(StateInfo state) {
        this.state = state;
    }
}