/*
 * Created on 29 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultDelta extends ValueListImpl implements Delta {
	
	protected DeltaKey key;
	
	
	private static int next_index; 
	
	protected class DeltaKey implements Comparable {
		int index;
		
		Variable variable;
	
		public DeltaKey(Variable v, int i) {
			setVariable(v);
			setIndex(i);
		}
		/* (non-Javadoc)
		 * @see java.lang.Comparable#compareTo(java.lang.Object)
		 */
		public int compareTo(Object o) {
			DeltaKey k = (DeltaKey)o;
			try {
				
				Variable v = k.getVariable();
				String vk = (String) v.getKey();
				int i = k.getIndex();
				String tk = (String) variable.getKey();
				int keyComp = tk.compareTo(vk);
				return  (keyComp == 0 ? index-i : keyComp);
			} catch (NullPointerException e) {
				solver.add(Solver.EXCEPTION, new SolverException("Impossible to compare "+this+" with "+k));
				return 1; 
			}
		}
		 
		public synchronized int getIndex() {
			return index;
		}
		/**
		 * @return Returns the variable.
		 */
		public synchronized Variable getVariable() {
			return variable;
		}
		/**
		 * @param index The index to set.
		 */
		public synchronized void setIndex(int idx) {
			if (idx > 0) this.index = idx;
		}
		/**
		 * @param variable The variable to set.
		 */
		public synchronized void setVariable(Variable var) {
			//System.out.println("SET DOMAIN KEY VARIABLE:"+var);
			if (var != null) this.variable = var;
		}
		
		
		public String toString() {
			StringBuffer buffer = new StringBuffer("DELTA KEY@");
			buffer.append(Integer.toHexString(this.hashCode()));
			buffer.append('[');
			buffer.append(variable);
			buffer.append(',');
			buffer.append(index);
			buffer.append(']');
			return buffer.toString();
		}
	}
	
	
	
	protected Variable variable;
	
	
	protected int chrono;
	protected int depth;
	
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Domain#getVariable()
	 */
	public synchronized Variable getVariable() {
		return variable;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Domain#setVariable(fr.inria.oadymppac.solver.Variable)
	 */
	public synchronized void setVariable(Variable variable) {
		this.variable = variable;
		updateKey();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getLabel()
	 */
	public synchronized String getLabel() {
		return (variable==null ? "" : variable.getLabel());
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getSolverType()
	 */
	public synchronized byte getSolverType() {
		return Solver.DOMAIN;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.utils.Indexable#getKey()
	 */
	public synchronized Object getKey() {
		return key;
	}
	/**
	 * @param solver
	 */
	public DefaultDelta(Solver solver) {
		super(solver);
		setIndex(next_index++);
		this.key =new DeltaKey(null,-1);
	}
	/**
	 * @return Returns the chrono.
	 */
	public synchronized int getChrono() {
		return chrono;
	}
	/**
	 * @param chrono The chrono to set.
	 */
	public synchronized void setChrono(int chrono) {
		this.chrono = chrono;
		updateKey();
	}
	/**
	 * @return Returns the depth.
	 */
	public synchronized int getDepth() {
		return depth;
	}
	/**
	 * @param depth The depth to set.
	 */
	public synchronized void setDepth(int depth) {
		this.depth = depth;
	}
	
	protected void updateKey() {
		if (key == null) {
			key = new DeltaKey(variable, chrono); 
		} else {
			key.setVariable(variable);
			key.setIndex(chrono);
		}
	}
	
	public String getEventType() {
		return Delta.EVENT_TYPE;
	}
	
	public void reset() {
		next_index=0;
	}
}
