/*
 * Created on 13 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

import java.util.Collection;
import java.util.Vector;


/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultReduce extends SolverEventElementImpl implements Reduce {
	
	
	private static int next_index=0;
	
	protected String algorithm;
	
	protected Variable variable=null;
	protected Constraint constraint=null;
	
	protected State state;
	protected Domain domain;
	protected Delta delta;
	protected Update update;
	
	protected Collection explanations;
	
	
	protected int reductionSize;
	protected boolean reductionSizeAvailable=false;
	/**
	 * @param solver
	 */
	public DefaultReduce(Solver solver) {
		super(solver);
		setIndex(next_index++);
	}
	

	
	public String toString() {
	StringBuffer buffer = new StringBuffer(super.toString());
	buffer.append("variable="+variable+" ");
	buffer.append("constraint="+variable+" ");
	buffer.append(super.toString());
	buffer.append("]");
	return buffer.toString();
	}

	/**
	 * @return Returns the constraint.
	 */
	public synchronized Constraint getConstraint() {
		return constraint;
	}
	/**
	 * @param constraint The constraint to set.
	 */
	public synchronized void setConstraint(Constraint constraint) {
		this.constraint = constraint;
		updateLabel();
	}
	/**
	 * @param variable The variable to set.
	 */
	public synchronized void setVariable(Variable variable) {
		this.variable = variable;
	}
	/**
	 * @return Returns the variable.
	 */
	public synchronized Variable getVariable() {
		return variable;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#getEventType()
	 */
	public String getEventType() {
		return Reduce.EVENT_TYPE;
	}
	
	private void updateLabel() {
		if (variable != null && constraint != null) {	
			label="reduce("+variable.getLabel()+","+constraint.getLabel()+")"; 
		}
	}
	
	
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverEventElementImpl#key(int)
	 */
	protected Object key(int i) {
		return ReduceManager.key(i);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getSolverType()
	 */
	public byte getSolverType() {
		return Solver.REDUCE;
	}
	/**
	 * @return Returns the state.
	 */
	public synchronized State getState() {
		return state;
	}
	/**
	 * @param state The state to set.
	 */
	public synchronized void setState(State state) {
		this.state = state;
	}
	/**
	 * @return Returns the delta.
	 */
	public synchronized Delta getDelta() {
		return delta;
	}
	/**
	 * @param delta The delta to set.
	 */
	public synchronized void setDelta(Delta delta) {
		this.delta = delta;
	}
	/**
	 * @return Returns the vardomain.
	 */
	public synchronized Domain getDomain() {
		return domain;
	}
	/**
	 * @param vardomain The vardomain to set.
	 */
	public synchronized void setDomain(Domain domain) {
		this.domain = domain;
	}
	/**
	 * @return Returns the algorithm.
	 */
	public synchronized String getAlgorithm() {
		return algorithm;
	}
	/**
	 * @param algorithm The algorithm to set.
	 */
	public synchronized void setAlgorithm(String algorithm) {
		this.algorithm = algorithm;
	}
	/**
	 * @return Returns the update.
	 */
	public synchronized Update getUpdate() {
		return update;
	}
	/**
	 * @param update The update to set.
	 */
	public synchronized void setUpdate(Update update) {
		this.update = update;
	}
	
	protected void buildExplanations() {
		if (explanations == null) explanations = new Vector(); 
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#addExplanation(fr.inria.oadymppac.solver.Explanation)
	 */
	public void addExplanation(Explanation explanation) {
		buildExplanations();
		if (!explanations.contains(explanation)) explanations.add(explanation);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#getExplanationCount()
	 */
	public int getExplanationCount() {
		return explanations.size();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#getExplanations()
	 */
	public Collection getExplanations() {
		return explanations;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#removeExplanation(fr.inria.oadymppac.solver.Explanation)
	 */
	public void removeExplanation(Explanation explanation) {
		if (explanations != null) explanations.remove(explanation);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Reduce#setExplanations(fr.inria.oadymppac.solver.Explanation[])
	 */
	public void setExplanations(Collection expls) {
		buildExplanations();
		this.explanations.clear();
		this.explanations.addAll(expls);
		
	}
	
	public void clearExplanations() {
		if (explanations != null) explanations.clear();
	}
	
	public int countExplanations() {
		return (explanations == null) ? 0 : explanations.size();
	}
	/**
	 * @return Returns the reductionSize.
	 */
	public synchronized int getReductionSize() {
		return reductionSize;
	}
	/**
	 * @param reductionSize The reductionSize to set.
	 */
	public synchronized void setReductionSize(int reductionSize) {
		this.reductionSize = reductionSize;
		this.reductionSizeAvailable=true;
	}
	
	/**
	 * @return Returns the reductionSizeAvailabe.
	 */
	public synchronized boolean isReductionSizeAvailable() {
		return reductionSizeAvailable;
	}
	
	public void reset() {
		next_index=0;
	}
}
