/*
 * Created on 8 avr. 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

import fr.inria.oadymppac.utils.Indexable;
import fr.inria.oadymppac.utils.ObjectManager;
import fr.inria.oadymppac.utils.Properties;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultSolver extends AbstractSolver {

    
    
    public synchronized int add(int type, Object element) {
    	ObjectManager manager = (ObjectManager) getFromIndex(type);
    	//System.out.println("ADDING NEW ELEMENT "+element+" INTO MANAGER "+manager.getClass());
        return (manager == null ? INVALID : manager.add(element));
    }
    
    
	/**
	 * @param properties
	 */
	public DefaultSolver(Properties properties) {
		super(properties);
		add(ExceptionManager.getExceptionManager(this));
        add(VariableManager.getVariableManager(this));
        add(ConstraintManager.getConstraintManager(this));
        add(SearchNodeManager.getSearchNodeManager(this));
        add(ReduceManager.getReduceManager(this));
        add(PostManager.getPostManager(this));
        add(BackToManager.getBackToManager(this));
        add(RemoveManager.getRemoveManager(this));
        add(RestoreManager.getRestoreManager(this));
        add(SuspendManager.getSuspendManager(this));
        add(SolvedManager.getSolvedManager(this));
        add(RejectManager.getRejectManager(this));
        add(AwakeManager.getAwakeManager(this));
        add(ScheduleManager.getScheduleManager(this));
        add(AnnotationManager.getAnnotationManager(this));
        add(StageManager.getStageManager(this));
        add(StateManager.getStateManager(this));
        add(UpdateManager.getUpdateManager(this));
        add(DeltaManager.getDeltaManager(this));
        add(DomainManager.getDomainManager(this));
        
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Solver#getConstraint(int)
	 */
	public synchronized Object get(int type , int i) {
		ObjectManager manager = (ObjectManager) getFromIndex(type); 
		return (manager == null ? null : manager.getFromIndex(i));
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Solver#getConstraint(java.lang.String)
	 */
	public synchronized int get(int type, Object key) {
		ObjectManager manager = (ObjectManager) getFromIndex(type); 
		return (manager == null ? INVALID : manager.getIndex(key));
	}
	
	
	/**
	 * @return Returns the constraints.
	 */
	public synchronized ObjectManager get(int type) {
		return (ObjectManager) getFromIndex(type);
	}
	
	public synchronized int add(Indexable element){
		int index = element.getIndex();
		//System.out.println("ADDING AT INDEX:"+index+" OBJECT:"+element);
    	indexer.put(element.getKey(), new Integer(index));
    	content.setSize(Math.max(index+1, content.size()));
    	content.setElementAt(element,element.getIndex());
    	return element.getIndex();
    }
	
	

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Solver#buildProxy(int)
	 */
	public SolverMainElement buildProxy(int type, Object identifier) {
		if (logger.isDebugEnabled()) logger.warn("Creating a proxy("+type+") for id:"+identifier);
		SolverMainElement result=null;
		switch (type) {
			case Solver.VARIABLE:
				VariableProxy var_proxy = new VariableProxy(this);
			var_proxy.setIdentifier(identifier.toString());
			add(Solver.VARIABLE, var_proxy);
			result=var_proxy;
			break;
			case Solver.CONSTRAINT:
				ConstraintProxy ctr_proxy = new ConstraintProxy(this);
			ctr_proxy.setIdentifier(identifier.toString());
			add(Solver.CONSTRAINT, ctr_proxy);
			result= ctr_proxy;
			break;
			case Solver.SEARCHNODE:
				SearchNodeProxy node_proxy = new SearchNodeProxy(this);
			node_proxy.setIdentifier(identifier.toString());
			add(Solver.SEARCHNODE, node_proxy);
			result= node_proxy;
			break;
			case Solver.ANNOTATION:
				AnnotationProxy ann_proxy = new AnnotationProxy(this);
			ann_proxy.setIdentifier(identifier.toString());
			add(Solver.ANNOTATION, ann_proxy);
			result=ann_proxy;
			break;
			case Solver.STAGE:
				StageProxy stg_proxy = new StageProxy(this);
			stg_proxy.setIdentifier(identifier.toString());
			add(Solver.STAGE, stg_proxy);
			result= stg_proxy;
			break;
		}
		return result;	
	}
	
	public void reset() {
		Annotation annotation = (Annotation) get(Solver.ANNOTATION,0);
		if (annotation != null ) annotation.reset();
		Awake awake = (Awake) get(Solver.AWAKE,0);
		if (awake != null ) awake.reset();
		BackTo backTo = (BackTo) get(Solver.BACKTO,0);
		if (backTo != null) backTo.reset();
		Cause cause = (Cause) get(Solver.CAUSE,0);
		if (cause != null) cause.reset();
		Constraint constraint = (Constraint) get(Solver.CONSTRAINT,0);
		if (constraint != null) constraint.reset();
		ConstraintStatus constraintStatus = (ConstraintStatus) get(Solver.CONSTRAINT_STATUS,0);
		if (constraintStatus != null) constraintStatus.reset();
		Delta delta = (Delta) get(Solver.DELTA,0);
		if (delta != null ) delta.reset();
		Domain domain = (Domain) get(Solver.DOMAIN, 0);
		if (domain != null) domain.reset();
		Explanation explanation = (Explanation) get(Solver.EXPLANATION,0);
		if (explanation != null) explanation.reset();
		Post post = (Post) get(Solver.POST, 0);
		if (post != null) post.reset();
		Reduce reduce = (Reduce) get(Solver.REDUCE,0);
		if (reduce != null) reduce.reset();
		Reject reject = (Reject) get(Solver.REJECT,0);
		if (reject != null) reject.reset();
		Remove remove = (Remove) get(Solver.REMOVE,0);
		if (remove != null) remove.reset();
		Restore restore = (Restore) get(Solver.RESTORE,0);
		if (restore != null) restore.reset();
		Schedule schedule = (Schedule) get(Solver.SCHEDULE,0);
		if (schedule != null) schedule.reset();
		SearchNode searchNode = (SearchNode) get(Solver.SEARCHNODE,0);
		if (searchNode != null) searchNode.reset();
		Solved solved = (Solved) get(Solver.SOLVED,0);
		if (solved != null) solved.reset();
		Stage stage = (Stage) get(Solver.STAGE,0);
		if (stage != null) stage.reset();
		State state = (State) get(Solver.STATE,0);
		if (state != null) state.reset();
		Suspend suspend = (Suspend) get(Solver.SUSPEND, 0);
		if (suspend != null) suspend.reset();
		Update update = (Update) get(Solver.UPDATE,0);
		if (update != null) update.reset();
		ValueList valueList = (ValueList) get(Solver.VALUELIST, 0);
		if (valueList != null) valueList.reset();
		Variable variable = (Variable) get(Solver.VARIABLE,0);
		if (variable != null) variable.reset();
		VariableStatus variableStatus = (VariableStatus) get(Solver.VARIABLE_STATUS,0);
		if (variableStatus != null) variableStatus.reset();
		StageEvent stageEvent = (StageEvent) get(Solver.STAGE_EVENT, 0);
		if (stageEvent != null ) stageEvent.reset();
		content.clear(); 
		indexer.clear();	
	}
}
