/*
 * Created on 13 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

import java.util.Collection;
import java.util.Vector;


/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultState extends SolverMainElementImpl implements State {
	private static int next_index=0;
	
	
	protected SearchNode currentNode;
    protected SearchNode nextNode;
    protected String nodeName;
    protected String status;
    protected String choiceConstraints;
    
    protected String misc;
    
	protected Collection variables;
	protected Collection constraints;
	protected Collection updates;
	
	
	
	/**
	 * @param solver
	 */
	public DefaultState(Solver solver) {
		super(solver);
		setIndex(next_index++);
	}
	
	public String getEventType() {
		return State.EVENT_TYPE;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getCurrentNode()
	 */
	public SearchNode getCurrentNode() {
		
		return currentNode;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getMisc()
	 */
	public String getMisc() {
		return misc;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getName()
	 */
	public String getName() {
		return nodeName;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setCurrentNode(fr.inria.oadymppac.solver.SearchNode)
	 */
	public void setCurrentNode(SearchNode node) {
		currentNode = node;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setMisc(java.lang.String)
	 */
	public void setMisc(String misc) {
		this.misc=misc;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setName(java.lang.String)
	 */
	public void setName(String name) {
		nodeName = name;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getLabel()
	 */
	public String getLabel() {
		return nodeName;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getSolverType()
	 */
	public byte getSolverType() {
		return Solver.STATE;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.utils.Indexable#getKey()
	 */
	public Object getKey() {

		return null;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#addConstraint(fr.inria.oadymppac.solver.ConstraintStatus)
	 */
	public void addConstraint(ConstraintStatus constraint) {
		buildConstraints();
		if (!constraints.contains(constraint)) constraints.add(constraint);
		
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#addUpdate(fr.inria.oadymppac.solver.Update)
	 */
	public void addUpdate(Update update) {
		buildUpdates();
		if (!updates.contains(update)) updates.add(update);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#addVariable(fr.inria.oadymppac.solver.VariableStatus)
	 */
	public void addVariable(VariableStatus variable) {
		buildVariables();
		if (!variables.contains(variable)) variables.add(variable);
	}
	
	protected void buildConstraints() {
		if (constraints == null) constraints = new Vector();
	}
	protected void buildVariables() {
		if (variables == null) variables = new Vector();
	}

	protected void buildUpdates() {
		if (updates == null) updates = new Vector();
	}

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#countConstraints()
	 */
	public int countConstraints() {
		return (constraints == null ? 0 : constraints.size());
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#countUpdates()
	 */
	public int countUpdates() {
		return (updates == null ? 0 : updates.size());
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#countVariables()
	 */
	public int countVariables() {
		return (variables == null ? 0 : variables.size());
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getConstraints()
	 */
	public Collection getConstraints() {
		return constraints;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getUpdate()
	 */
	public Collection getUpdates() {
		return updates;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#getVariables()
	 */
	public Collection getVariables() {
		return variables;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#removeConstraint(fr.inria.oadymppac.solver.ConstraintStatus)
	 */
	public void removeConstraint(ConstraintStatus constraint) {
		if (constraints != null) constraints.remove(constraint);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#removeUpdate(fr.inria.oadymppac.solver.Update)
	 */
	public void removeUpdate(Update update) {
		if (updates != null) updates.remove(update);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#removeVariable(fr.inria.oadymppac.solver.VariableStatus)
	 */
	public void removeVariable(VariableStatus variable) {
		if (variables != null) variables.remove(variable);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setConstraints(fr.inria.oadymppac.solver.ConstraintStatus[])
	 */
	public void setConstraints(Collection constraints) {
		buildConstraints();
		this.constraints.clear();
		this.constraints.addAll(constraints);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setUpdate(fr.inria.oadymppac.solver.Update[])
	 */
	public void setUpdates(Collection updates) {
		buildUpdates();
		this.updates.clear();
		this.updates.addAll(updates);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.State#setVariables(fr.inria.oadymppac.solver.VariableStatus[])
	 */
	public void setVariables(Collection variables) {
		buildVariables();
		this.variables.clear();
		this.variables.addAll(variables);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.VariableStatusCollection#clearVariables()
	 */
	public void clearVariables() {
		if (variables != null) variables.clear();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.ConstraintStatusCollection#clearConstraints()
	 */
	public void clearConstraints() {
		if (constraints != null) constraints.clear();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.UpdateCollection#clearUpdate()
	 */
	public void clearUpdates() {
		if (updates != null) updates.clear();
	}
	
	public void reset() {
		next_index=0;
	}
}
