/*
 * $Id: SolverElementImpl.java,v 1.4 2004/05/28 06:28:47 raf Exp $
 *
 * Copyright (c) 2001-2002 Jean-Daniel Fekete, Mohammad Ghoniem and
 * Ecole des Mines de Nantes.  All rights reserved.
 *
 * This software is proprietary information of Jean-Daniel Fekete and
 * Ecole des Mines de Nantes.  You shall use it only in accordance
 * with the terms of the license agreement you accepted when
 * downloading this software.  The license is available in the file
 * licence.txt and at the following URL:
 * http://www.emn.fr/fekete/oadymppac/licence.html
 */
package fr.inria.oadymppac.solver;

import fr.inria.oadymppac.utils.*;

public abstract class SolverElementImpl implements SolverManagable,Indexable {
    
    protected Solver solver;
    
    /**
     * Generator of static ids.
     */
  //  protected static int next_index;
    
    /**
     * Unique number associated with this variable.
     */
    protected int index;

    

    public SolverElementImpl(Solver solver) {
        setSolver(solver);
    }

    /**
    * Get the value of id.
    * @return value of id.
    */
    public synchronized int getIndex() {
        return index;
    }
    
    
    /**
     * @param index The index to set.
     */
    public synchronized void setIndex(int index) {
        this.index = index;
    }
    /**
     * @return Returns the solver.
     */
    public synchronized Solver getSolver() {
        return solver;
    }
    /**
     * @param solver The solver to set.
     */
    public synchronized void setSolver(Solver solver) {
        this.solver = solver;
    }
}
