/*
 * Created on 6 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.analyser;

import infovis.Graph;
import infovis.Table;
import infovis.column.IntColumn;
import infovis.column.StringColumn;
import fr.inria.infovis.column.LayeredColumnProxy;
import fr.inria.infovis.graph.DefaultLayeredGraph;
import fr.inria.infovis.table.DefaultLayeredTable;
import fr.inria.infovis.table.LayeredTable;
import fr.inria.infovis.temporizer.AbstractTemporizer;
import fr.inria.infovis.temporizer.GraphTemporizer;
import fr.inria.oadymppac.application.ApplicationProperties;
import fr.inria.oadymppac.panel.HistoryController;
import fr.inria.oadymppac.panel.HistoryModel;
import fr.inria.oadymppac.panel.VisualizationFrameDecorator;
import fr.inria.oadymppac.solver.Solver;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class AbstractGraphAnalyser extends SolverAnalyserImpl {
	

	Graph graph;
	AbstractTemporizer temporizer;
	WeightCalculator reduceWeightCalculator;
	
	Table nodeTable;
	


	IntColumn 	 chronoColumnNode;
	IntColumn 	 invChronoColumnNode;
	IntColumn 	 depthColumnNode;
	IntColumn 	 invDepthColumnNode;
	StringColumn identifierColumnNode;
	StringColumn labelColumnNode;
	StringColumn nameColumnNode;
	StringColumn typeColumnNode;
	IntColumn    numTypeColumnNode;
	StringColumn internalColumnNode;
	StringColumn externalColumnNode;
	//IntColumn    activationColumnNode;
	LayeredColumnProxy    activationColumnNode;
	IntColumn    invActivationColumnNode;
	//IntColumn    metricColumnNode;
	//IntColumn    internalMetricColumnNode;
	LayeredColumnProxy    metricColumnNode;
	
	IntColumn    invMetricColumnNode; 

	
	
	
	Table edgeTable;
	IntColumn 	 chronoColumnEdge;
	IntColumn 	 invChronoColumnEdge;
	IntColumn 	 depthColumnEdge;
	IntColumn 	 invDepthColumnEdge;
	StringColumn labelColumnEdge;
	StringColumn typeColumnEdge;
	IntColumn    numTypeColumnEdge;
	//IntColumn    activationColumnEdge;
	LayeredColumnProxy    activationColumnEdge;
	IntColumn    invActivationColumnEdge;
	//IntColumn    metricColumnEdge;
	LayeredColumnProxy    metricColumnEdge;
	IntColumn    invMetricColumnEdge;
	

	
	protected void buildWeightCalculator() {
		if (reduceWeightCalculator == null) reduceWeightCalculator = new ReduceWeightCalculator();
	}
	
	protected int addEdge(int layer, int index, int from, int to, int metric) {
		int current;
		int edge=graph.getEdge(from,to);
		if ( edge== Graph.NIL) {
			edge = graph.addEdge(from,to);
			//if (logger.isDebugEnabled()) logger.info("ADDED EDGE #"+edge+" (from="+from+",to="+to+")");
			//System.out.println("ADDED EDGE #"+edge+" (from="+from+",to="+to+")");
			activationColumnEdge.setValueOrNullAt(layer,edge, "1");
			invActivationColumnEdge.setExtend(edge, -1);
			
			current = Integer.parseInt(activationColumnNode.getValueAt(to));
			current = (current == Integer.MIN_VALUE ? 0 : current);
			activationColumnNode.setValueOrNullAt(layer,to, Integer.toString(current+1));
			invActivationColumnNode.setExtend(to, -current-1);
			
			current = Integer.parseInt(activationColumnNode.getValueAt(from));
			current = (current == Integer.MIN_VALUE ? 0 : current);
			activationColumnNode.setValueOrNullAt(layer,from, Integer.toString(current+1));
			invActivationColumnNode.setExtend(from, -current-1);
			
			
			
			metricColumnEdge.setValueOrNullAt(layer,edge,Integer.toString(metric));
			invMetricColumnEdge.setExtend(edge, -metric);
			
			
			current = Integer.parseInt(metricColumnNode.getValueAt(to));
			current = (current == Integer.MIN_VALUE ? 0 : current);					
			metricColumnNode.setValueOrNullAt(layer,to,Integer.toString(current+metric));
			invMetricColumnNode.setExtend(to, -current-metric);
			
			
		
			current = Integer.parseInt(metricColumnNode.getValueAt(from));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			metricColumnNode.setValueOrNullAt(layer,from,Integer.toString(current+metric));	
			invMetricColumnNode.setExtend(from, -current-metric);
			return edge;
		} else {
			//if (logger.isDebugEnabled()) logger.warn("Edge already created, incrementing activation");
			//System.out.println("Edge already created, incrementing activation");
			
			current = Integer.parseInt(activationColumnEdge.getValueAt(edge));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			activationColumnEdge.setValueOrNullAt(layer,edge,Integer.toString(current+1));
			invActivationColumnEdge.setExtend(edge,-current-1);
			
			current = Integer.parseInt(activationColumnNode.getValueAt(to));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			activationColumnNode.setValueOrNullAt(layer,to, Integer.toString(current+1));

			invActivationColumnNode.setExtend(to, -current-1);
			
			current = Integer.parseInt(activationColumnNode.getValueAt(from));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			activationColumnNode.setValueOrNullAt(layer,from, Integer.toString(current+1));		
			invActivationColumnNode.setExtend(from, -current-1);	
			
			current = Integer.parseInt(metricColumnEdge.getValueAt(edge));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			metricColumnEdge.setValueOrNullAt(layer,edge,Integer.toString(current+metric));
			invMetricColumnEdge.setExtend(edge,-current-metric);
		
			current = Integer.parseInt(metricColumnNode.getValueAt(to));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			metricColumnNode.setValueOrNullAt(layer,to,Integer.toString(current+metric));		
			invMetricColumnNode.setExtend(to, -current-metric);
			
			
			current = Integer.parseInt(metricColumnNode.getValueAt(from));
			current = (current == Integer.MIN_VALUE ? 0 : current);		
			metricColumnNode.setValueOrNullAt(layer,from,Integer.toString(current+metric));
			invMetricColumnNode.setExtend(from, -current-metric);
			return Graph.NIL;
		}
	}
	/**
	 * @return Returns the graph.
	 */
	public Graph getGraph() {
		if (graph == null) init_graph();
		return graph;
	}
	/**
	 * @param graph The graph to set.
	 */
	public void setGraph(Graph graph) {
		this.graph = graph;
	}
	/**
	 * @return Returns the table.
	 */
	public Table getNodeTable() {
		return nodeTable;
	}
	/**
	 * @param table The table to set.
	 */
	public void setNodeTable(Table table) {
		this.nodeTable = table;
	}
	
	protected void init_graph() {
		logger.info("Init Variable Constraint Graph and Table");
		
		nodeTable = new DefaultLayeredTable();
		nodeTable.setName(getLabel());
		chronoColumnNode=new IntColumn("Chrono");
		nodeTable.addColumn(chronoColumnNode);
		invChronoColumnNode=new IntColumn("Inv.Chrono");
		nodeTable.addColumn(invChronoColumnNode);
		depthColumnNode=new IntColumn("Depth");
		nodeTable.addColumn(depthColumnNode);
		invDepthColumnNode=new IntColumn("Inv.Depth");
		nodeTable.addColumn(invDepthColumnNode);
		identifierColumnNode=new StringColumn("Identfier");
		nodeTable.addColumn(identifierColumnNode);
		labelColumnNode=new StringColumn("Label");
		nodeTable.addColumn(labelColumnNode);
		nameColumnNode=new StringColumn("Name");
		nodeTable.addColumn(nameColumnNode);
		typeColumnNode=new StringColumn("Type");
		nodeTable.addColumn(typeColumnNode);
		numTypeColumnNode=new IntColumn("Num.Type");
		nodeTable.addColumn(numTypeColumnNode);
		internalColumnNode=new StringColumn("Internal");
		nodeTable.addColumn(internalColumnNode);
		externalColumnNode=new StringColumn("External");
		nodeTable.addColumn(externalColumnNode);
		activationColumnNode=new LayeredColumnProxy(new IntColumn("Activation"));
		nodeTable.addColumn(activationColumnNode);
		invActivationColumnNode=new IntColumn("Inv.Activation");
		nodeTable.addColumn(invActivationColumnNode);
		metricColumnNode= new LayeredColumnProxy(new IntColumn("Propagation Qty"));
		nodeTable.addColumn(metricColumnNode);
		invMetricColumnNode= new IntColumn("Inv.Propagation Qty");
		nodeTable.addColumn(invMetricColumnNode);
		

		
		edgeTable = new DefaultLayeredTable();
		edgeTable.setName(getLabel());
		chronoColumnEdge = new IntColumn("Chrono");
		edgeTable.addColumn(chronoColumnEdge);
		invChronoColumnEdge=new IntColumn("Inv.Chrono");
		edgeTable.addColumn(invChronoColumnEdge);
		depthColumnEdge=new IntColumn("Depth");
		edgeTable.addColumn(depthColumnEdge);
		invDepthColumnEdge=new IntColumn("Inv.Depth");
		edgeTable.addColumn(invDepthColumnEdge);
		labelColumnEdge=new StringColumn("Label");
		edgeTable.addColumn(labelColumnEdge);
		typeColumnEdge = new StringColumn("Type");
		edgeTable.addColumn(typeColumnEdge);
		numTypeColumnEdge=new IntColumn("Num.Type");
		edgeTable.addColumn(numTypeColumnEdge);

		activationColumnEdge=new LayeredColumnProxy(new IntColumn("Activation"));
		edgeTable.addColumn(activationColumnEdge);
		invActivationColumnEdge=new IntColumn("Inv.Activation");
		edgeTable.addColumn(invActivationColumnEdge);
//		metricColumnEdge= new IntColumn("Metric");
		metricColumnEdge = new LayeredColumnProxy(new IntColumn("Propagation Qty"));
		edgeTable.addColumn(metricColumnEdge);
		invMetricColumnEdge= new IntColumn("Inv.Propagation Qty");
		edgeTable.addColumn(invMetricColumnEdge);
		
		graph = new DefaultLayeredGraph(edgeTable,nodeTable);
		
		temporizer = new GraphTemporizer(graph);
		temporizer.start();
	}
	/**
	 * @return Returns the lABEL.
	 */
	public abstract String getLabel();
	
	
	/**
	 * @param solver
	 */
	public AbstractGraphAnalyser(Solver solver) {
		super(solver);
	}
	
	public void endAnalyse() {

		temporizer.stop();
		VisualizationFrameDecorator deco = (VisualizationFrameDecorator) solver.getProperty(ApplicationProperties.VISUALIZATION_FRAME_DECORATOR);
		
		 HistoryController historyController = (HistoryController) deco.getHistoryController();
		 
		 
		 if (historyController != null ) {
		 	double value = (double) solver.getIntValue(Solver.CHRONO_MIN);
		 	double extent = (double)  solver.getIntValue(Solver.CHRONO_MAX) - value;
		 	HistoryModel hmodel = historyController.getModel();
		 	hmodel = (hmodel==null ?
		 		new HistoryModel(value,
		 			extent,
					value,
					value+extent) : hmodel);
		 	if (graph != null && graph instanceof LayeredTable) {
		 		LayeredTable layers = (LayeredTable) graph; 
		 		hmodel.setColumns(layers.getLayeredColumns());
		 	}
		 	hmodel.setRangeProperties(value,extent,0.0,extent+value, false);
		 	historyController.setModel(hmodel);
		 	
		 	
		 }
	}
	
	
	/**
	 * @return Returns the temporizer.
	 */
	public synchronized AbstractTemporizer getTemporizer() {
		return temporizer;
	}
	/**
	 * @param temporizer The temporizer to set.
	 */
	public synchronized void setTemporizer(AbstractTemporizer temporizer) {
		this.temporizer = temporizer;
	}
}
