/*
 * Created on 3 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import java.util.Collection;
import java.util.Iterator;

import fr.inria.oadymppac.parsing.info.EventInfo;
import fr.inria.oadymppac.parsing.info.NewConstraintInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.solver.Constraint;
import fr.inria.oadymppac.solver.ConstraintManager;
import fr.inria.oadymppac.solver.ConstraintProxy;
import fr.inria.oadymppac.solver.DefaultState;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.SolverMainElement;
import fr.inria.oadymppac.solver.State;
import fr.inria.oadymppac.solver.Update;
import fr.inria.oadymppac.solver.Variable;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultConstraintAdapter extends DefaultAdapter implements ConstraintAdapter{
	/**
	 * @param solver
	 */
	
	private String buffer;
	
	protected UpdateAdapter updateAdapter;
	protected StateAdapter stateAdapter;
	
	
	public DefaultConstraintAdapter(Solver solver) {
		super(solver);
		// TODO Auto-generated constructor stub
	}
	
	
	public  void  adapt(NewConstraintInfo info, Constraint element) throws SolverException {
		adaptEvent((EventInfo)info, (SolverMainElement) element);
		buffer = info.getExternal();  		
		element.setExternal(buffer==NewConstraintInfo.EXTERNAL_NONE ? NONE : buffer);
		buffer = info.getInternal(); 
		element.setInternal(buffer==NewConstraintInfo.INTERNAL_NONE ? NONE : buffer);
		buffer = info.getName(); 
		buffer = (buffer==NewConstraintInfo.NAME_NONE ? element.getExternal() : buffer);
		buffer = (buffer==NONE ? element.getInternal() : buffer);
		buffer = (buffer==NONE ? element.getIdentifier() : buffer);  
		element.setName(buffer);
		String ctrId = info.getIdentifier();
		if (ctrId.equals(NewConstraintInfo.IDENTIFIER_NONE)) {
			throw new SolverException("INVALID CONSTRAINT IDENTIFIER AT "+info.getChrono());
		} else {
			int ctr=solver.get(Solver.CONSTRAINT,ctrId);
			if (ctr != ConstraintManager.INVALID) {
				ConstraintProxy proxy = (ConstraintProxy)solver.get(Solver.CONSTRAINT, ctr);
				if (proxy != null) proxy.setProxy(element);
			} else {
				solver.add(Solver.CONSTRAINT,element);
			}
		}
		UpdateListInfo updates= info.getUpdateList();
		StateInfo st = info.getState();
		Variable variable=null;
		if (updates != null) {
			if (updateAdapter != null) updateAdapter.adapt(updates, element);		
			// Set link between variable and constraints based on Updates given in new cosntraints
			Collection upds = element.getUpdates();	
			Iterator it =(upds == null ? null : upds.iterator());
			Update upd;
			while(it != null && it.hasNext()) {
				upd = (Update) it.next();
				variable = (Variable) upd.getElement();
				if (variable != null) {
					variable.addConstraint(element);
					element.addVariable(variable);
					System.out.println("Variable Added from update");
				}
			}
		}
		if (st != null) {
			State state = new DefaultState(this.getSolver());
			if (stateAdapter != null) stateAdapter.adapt(st,state);
			element.setState(state);
		}
		
	}
	
	
	
	/**
	 * @return Returns the stateAdapter.
	 */
	public synchronized StateAdapter getStateAdapter() {
		return stateAdapter;
	}
	/**
	 * @param stateAdapter The stateAdapter to set.
	 */
	public synchronized void setStateAdapter(StateAdapter stateAdapter) {
		this.stateAdapter = stateAdapter;
	}
	/**
	 * @return Returns the updateAdapter.
	 */
	public synchronized UpdateAdapter getUpdateAdapter() {
		return updateAdapter;
	}
	/**
	 * @param updateAdapter The updateAdapter to set.
	 */
	public synchronized void setUpdateAdapter(UpdateAdapter updateAdapter) {
		this.updateAdapter = updateAdapter;
	}
}
