/*
 * Created on 4 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.info.ConstraintInfo;
import fr.inria.oadymppac.parsing.info.ConstraintListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.VariablesInfo;
import fr.inria.oadymppac.solver.Constraint;
import fr.inria.oadymppac.solver.ConstraintManager;
import fr.inria.oadymppac.solver.ConstraintStatus;
import fr.inria.oadymppac.solver.ConstraintStatusCollection;
import fr.inria.oadymppac.solver.DefaultConstraintStatus;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.State;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.solver.VariableManager;
import fr.inria.oadymppac.solver.VariableProxy;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultConstraintStatusAdapter extends DefaultAdapter
		implements
			ConstraintStatusAdapter {
	
	
	protected UpdateAdapter updateAdapter;
	/**
	 * @param solver
	 */
	public DefaultConstraintStatusAdapter(Solver solver) {
		super(solver);
		// TODO Auto-generated constructor stub
	}
	
	
	 public void adapt(ConstraintListInfo constraints, ConstraintStatusCollection element) throws SolverException {
	 	ConstraintStatus constraintStatus;
        ConstraintInfo info;
        Iterator it = (constraints == null ? null : constraints.iterator());
        State state= null;
    	if (element instanceof State) {
    		state =(State)element;
    	}
        while (it != null && it.hasNext()) {
            info = (ConstraintInfo) it.next();
            constraintStatus = new DefaultConstraintStatus(solver);
            adapt(info, constraintStatus);
            element.addConstraint(constraintStatus);
            constraintStatus.setState(state);
        }
    }
    
	 public void adapt(ConstraintInfo info, ConstraintStatus element) throws SolverException {
	 	Constraint constraint=null;
	 	String ctrId = info.getIdentifier();
	 	if (!ctrId.equals(ConstraintInfo.IDENTIFIER_NONE)) {
	 		int ctr = solver.get(Solver.CONSTRAINT,ctrId);
	 		if (ctr != ConstraintManager.INVALID ) {
	 			constraint = (Constraint) solver.get(Solver.CONSTRAINT, ctr);
	 		} else {
	 			solver.buildProxy(Solver.CONSTRAINT, info.getIdentifier());
	 		}
	 		element.setElement(constraint);
	 	}
	 	UpdateListInfo updateList = info.getUpdateList();
	 	if (updateList != null && updateAdapter != null) updateAdapter.adapt(updateList, element);
	 	
	 	VariablesInfo variables = info.getVariables();
	 	String[] identifiers = variables == null ? null : variables.getIdentifiers();
	 	if (identifiers != null && identifiers.length > 0) {
	 		int var;
	 		Variable variable;
	 		for (int id=0; id < identifiers.length; id++) {
	 			var = solver.get(Solver.VARIABLE, identifiers[id]);
	 			if (var != VariableManager.INVALID) {
	 				variable = (Variable)solver.get(Solver.VARIABLE, var);
	 			} else {
	 				variable = (VariableProxy)solver.buildProxy(Solver.VARIABLE, identifiers[id]);
	 			}
	 			if (variable != null && constraint != null) {
	 				variable.addConstraint(constraint);
	 				constraint.addVariable(variable);
	 				System.out.println("Variable Added from state");
	 			}
	 		}
	 		
	 	}
	 }
	 
	
	
	/**
	 * @return Returns the updateAdapter.
	 */
	public synchronized UpdateAdapter getUpdateAdapter() {
		return updateAdapter;
	}
	/**
	 * @param updateAdapter The updateAdapter to set.
	 */
	public synchronized void setUpdateAdapter(UpdateAdapter updateAdapter) {
		this.updateAdapter = updateAdapter;
	}
}
