/*
 * Created on 3 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import fr.inria.oadymppac.parsing.info.DeltaInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.ReduceInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.solver.Constraint;
import fr.inria.oadymppac.solver.ConstraintManager;
import fr.inria.oadymppac.solver.ConstraintProxy;
import fr.inria.oadymppac.solver.DefaultDelta;
import fr.inria.oadymppac.solver.DefaultDomain;
import fr.inria.oadymppac.solver.DefaultState;
import fr.inria.oadymppac.solver.DefaultUpdate;
import fr.inria.oadymppac.solver.Delta;
import fr.inria.oadymppac.solver.Domain;
import fr.inria.oadymppac.solver.Reduce;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.State;
import fr.inria.oadymppac.solver.Update;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.solver.VariableManager;
import fr.inria.oadymppac.solver.VariableProxy;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultReduceAdapter extends DefaultAdapter implements ReduceAdapter{
	/**
	 * @param solver
	 */
	
	protected DeltaAdapter deltaAdapter;
	protected DomainAdapter domainAdapter;
	protected UpdateAdapter updateAdapter;
	protected StateAdapter stateAdapter;
	protected ExplanationAdapter explanationAdapter;
	
	
	public DefaultReduceAdapter(Solver solver) {
		super(solver);
		
	}
	
	public  void  adapt(ReduceInfo info, Reduce element) throws SolverException {
		adaptEvent(info, element);
		solver.add(Solver.REDUCE, element);
		Variable variable=null;
		Constraint constraint=null;
		String varId = info.getVariable();
		
		if (!varId.equals(ReduceInfo.VARIABLE_NONE)) {
			int var = solver.get(Solver.VARIABLE, varId);
			if (var != VariableManager.INVALID) {
				variable = (Variable) solver.get(Solver.VARIABLE, var);
			} else {
				variable = (VariableProxy)solver.buildProxy(Solver.VARIABLE, info.getVariable());
			}
			element.setVariable(variable);
		}
		String ctrId = info.getConstraint();
		if (!ctrId.equals(ReduceInfo.CONSTRAINT_NONE)) {
			int ctr = solver.get(Solver.CONSTRAINT,ctrId);
			if (ctr != ConstraintManager.INVALID ) {
				constraint = (Constraint) solver.get(Solver.CONSTRAINT, ctr);
			} else {
				constraint = (ConstraintProxy) solver.buildProxy(Solver.CONSTRAINT, info.getConstraint());
			}
			element.setConstraint(constraint);
		}
		if (constraint != null && variable != null) {
			constraint.addVariable(variable);
			variable.addConstraint(constraint);
		}
		DeltaInfo dlt = info.getDelta();
		
		if (dlt != null) {
			
			Delta delta= new DefaultDelta(solver);
			if (deltaAdapter != null) deltaAdapter.adapt(dlt, delta);
				if (variable != null) {
					delta.setVariable(variable);
					variable.addDelta(delta);
				}
			element.setDelta(delta);
		}
		VarDomainInfo vardom = info.getVarDomain();
		if (vardom != null) {
			Domain domain= new DefaultDomain(solver);
			if (domainAdapter != null) domainAdapter.adapt(vardom, domain);
			if (variable != null) {
				domain.setVariable(variable);
				variable.addDomain(domain);
			}
			element.setDomain(domain);
		}
		UpdateInfo upd = info.getUpdate();
		if (upd != null) {
			Update update = new DefaultUpdate(solver);
			if (updateAdapter != null) updateAdapter.adapt(upd,update);
			variable = (Variable) update.getElement();
			if (constraint != null && variable != null) {
				constraint.addVariable(variable);
				variable.addConstraint(constraint);
			}
		}
		ExplanationListInfo expl = info.getExplanationList();
		if (expl != null) {
			if (explanationAdapter != null) explanationAdapter.adapt(expl, element);
		}
		StateInfo st = info.getState();
		if (st != null) {
			State state = new DefaultState(this.getSolver());
			if (stateAdapter != null) stateAdapter.adapt(st,state);
			element.setState(state);
		}
	}
	
	/**
	 * @return Returns the deltaAdapter.
	 */
	public synchronized DeltaAdapter getDeltaAdapter() {
		return deltaAdapter;
	}
	/**
	 * @param deltaAdapter The deltaAdapter to set.
	 */
	public synchronized void setDeltaAdapter(DeltaAdapter deltaAdapter) {
		this.deltaAdapter = deltaAdapter;
	}
	/**
	 * @return Returns the domainAdapter.
	 */
	public synchronized DomainAdapter getDomainAdapter() {
		return domainAdapter;
	}
	/**
	 * @param domainAdapter The domainAdapter to set.
	 */
	public synchronized void setDomainAdapter(DomainAdapter domainAdapter) {
		this.domainAdapter = domainAdapter;
	}
	/**
	 * @return Returns the stateAdapter.
	 */
	public synchronized StateAdapter getStateAdapter() {
		return stateAdapter;
	}
	/**
	 * @param stateAdapter The stateAdapter to set.
	 */
	public synchronized void setStateAdapter(StateAdapter stateAdapter) {
		this.stateAdapter = stateAdapter;
	}
	/**
	 * @return Returns the updateAdapter.
	 */
	public synchronized UpdateAdapter getUpdateAdapter() {
		return updateAdapter;
	}
	/**
	 * @param updateAdapter The updateAdapter to set.
	 */
	public synchronized void setUpdateAdapter(UpdateAdapter updateAdapter) {
		this.updateAdapter = updateAdapter;
	}
	/**
	 * @return Returns the explanationAdapter.
	 */
	public synchronized ExplanationAdapter getExplanationAdapter() {
		return explanationAdapter;
	}
	/**
	 * @param explanationAdapter The explanationAdapter to set.
	 */
	public synchronized void setExplanationAdapter(
			ExplanationAdapter explanationAdapter) {
		this.explanationAdapter = explanationAdapter;
	}
}
