/*
 * Created on 4 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.parsing.info.VariableInfo;
import fr.inria.oadymppac.parsing.info.VariableListInfo;
import fr.inria.oadymppac.solver.DefaultDomain;
import fr.inria.oadymppac.solver.DefaultVariableStatus;
import fr.inria.oadymppac.solver.Domain;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.State;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.solver.VariableManager;
import fr.inria.oadymppac.solver.VariableStatus;
import fr.inria.oadymppac.solver.VariableStatusCollection;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultVariableStatusAdapter extends DefaultAdapter
		implements
			VariableStatusAdapter {
	
	protected DomainAdapter domainAdapter;
	/**
	 * @param solver
	 */
	public DefaultVariableStatusAdapter(Solver solver) {
		super(solver);
	}
	
	
	public void adapt(VariableListInfo variables, VariableStatusCollection element) throws SolverException {
        VariableInfo info;
        VariableStatus variableStatus;
        Iterator it = (variables == null ? null : variables.iterator());
        State state= null;
    	if (element instanceof State) {
    		state =(State)element;
    	}
        while (it != null && it.hasNext()) {
            info = (VariableInfo) it.next();
            variableStatus = new DefaultVariableStatus(solver);
            adapt(info, variableStatus);
            element.addVariable(variableStatus);
            variableStatus.setState(state);
        }
    }
	
	
	
	

    public void adapt(VariableInfo info, VariableStatus element) throws SolverException {
    	Variable variable=null;		
    	String varId = info.getIdentifier();
    	if (!varId.equals(VariableInfo.IDENTIFIER_NONE)) {
    		int var = solver.get(Solver.VARIABLE, varId );
    		if (var != VariableManager.INVALID) {
    			variable = (Variable) solver.get(Solver.VARIABLE, var);
    		} else {
    			solver.buildProxy(Solver.VARIABLE, info.getIdentifier());
    		}
    		
    		element.setElement(variable);
    	}
		element.setType(info.getType());
		int min= VarDomainInfo.MIN_NONE;
		int max=VarDomainInfo.MAX_NONE;
		int size=VarDomainInfo.SIZE_NONE;
		VarDomainInfo vardom = info.getVarDomain();
		ValueListInfo dom= info.getValueList();//OLD DTD Style
		Domain domain=null;
		if (vardom != null || dom !=null) {
			domain = new DefaultDomain(this.getSolver());
		}
		if (vardom != null && domain !=null) {
			if (domainAdapter != null) domainAdapter.adapt(vardom,domain);
			
		} else if (dom != null && domain !=null ) {
			if (domainAdapter != null) domainAdapter.adapt(dom,domain);
		}
		if (domain != null) {
			element.setDomain(domain);
			if (variable != null) variable.addDomain(domain);
		}
    }
	/**
	 * @return Returns the domainAdapter.
	 */
	public synchronized DomainAdapter getDomainAdapter() {
		return domainAdapter;
	}
	/**
	 * @param domainAdapter The domainAdapter to set.
	 */
	public synchronized void setDomainAdapter(DomainAdapter domainAdapter) {
		this.domainAdapter = domainAdapter;
	}
}
