/* 
 * ### Copyright (C) 2001-2003 Michael Fuchs ###
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *      
 * Author: Michael Fuchs
 * E-Mail: mfuchs@unico-consulting.com
 *
 * RCS Information:
 * ---------------
 * Id.........: $Id: OptionException.java, v 1.1.1.1 2003/10/21 19:19:15 cvs Exp $
 * Author.....: $Author: cvs $
 * Date.......: $Date: 2003/10/21 19:19:15 $
 * Revision...: $Revision: 1.1.1.1 $
 * State......: $State: Exp $
 */
package com.mf.option;

import java.io.PrintWriter;
import java.io.StringWriter;



/**
 * Describe class <code>OptionException</code> here.
 *
 * @author <a href="mailto:mfuchs@unico-consulting.com">Michael Fuchs</a>
 * @version 1.0
 */
public class OptionException extends RuntimeException {

    private Exception cause;
    private String msg;

    /**
     * Creates a new <code>OptionException</code> instance.
     *
     * @param msg a <code>String</code> value
     */
    public OptionException(String msg) {

        super(msg);

        this.msg = msg;
        this.cause = null;
    }
    
    /**
     * Creates a new <code>OptionException</code> instance.
     *
     * @param oops an <code>Exception</code> value
     */
    public OptionException(Exception oops) {

        super(oops.getMessage());

        this.msg = "";
        this.cause = oops;
    }

    /**
     * Describe <code>getMessage</code> method here.
     *
     * @return an <code>Exception</code> value
     */
    public String getMessage() {

        if (cause == null) {
            return msg;
        } 

        StringWriter buffer = new StringWriter();
        cause.printStackTrace(new PrintWriter(buffer));
        return buffer.toString();
    }
}
/*
 * $Log: OptionException.java, v $
 * Revision 1.1.1.1  2003/10/21 19:19:15  cvs
 * Getopts library.
 *
 * Revision 1.1  2003/08/13 18:39:47  mfuchs
 * Option
 *
 * Revision 1.1  2003/08/12 19:28:10  mfuchs
 * log4j properties files for differnet logging levels.
 *
 */
