<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  
  <xsl:output method="xml" 
    omit-xml-declaration="yes"
    encoding="iso-8859-1" 
    indent="yes"/>

  <xsl:template match="class">
    <classsynopsis>
      <ooclass>
        <modifier><xsl:value-of select="modifier"/></modifier>
        <classname><xsl:value-of select="name"/></classname>
      </ooclass>
      <xsl:apply-templates select="//constructor"/>
      <xsl:apply-templates select="//field"/>
      <xsl:apply-templates select="//method"/>
    </classsynopsis>
  </xsl:template>

  <xsl:template match="constructor">
    <constructorsynopsis>
      <modifier><xsl:value-of select="modifier"/></modifier>
      <methodname><xsl:value-of select="name"/></methodname>
      <xsl:choose>
        <xsl:when test="count(parameters/parameter) = 0">
          <void/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="parameters/parameter"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="exceptions/exception"/>
    </constructorsynopsis>
  </xsl:template>

  <xsl:template match="field">
    <fieldsynopsis>
      <modifier><xsl:value-of select="modifier"/></modifier>
      <type><xsl:value-of select="type"/></type>
      <varname><xsl:value-of select="name"/></varname>
    </fieldsynopsis>
  </xsl:template>

  <xsl:template match="method">
    <methodsynopsis>
      <modifier><xsl:value-of select="modifier"/></modifier>
      <type><xsl:value-of select="return"/></type>
      <methodname><xsl:value-of select="name"/></methodname>
      <xsl:choose>
        <xsl:when test="count(parameters/parameter) = 0">
          <void/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="parameters/parameter"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="exceptions/exception"/>
    </methodsynopsis>
  </xsl:template>

  <xsl:template match="//parameter">
    <methodparam>
      <type><xsl:value-of select="type"/></type>
      <parameter><xsl:value-of select="name"/></parameter>
    </methodparam>
  </xsl:template>

  <xsl:template match="//exception">
    <exceptionname><xsl:value-of select="type"/></exceptionname>
  </xsl:template>

</xsl:stylesheet>